' Tab stops should be set at 2 for this file
'need global HX,HY
'editstring pretext

'*********************************
'*                               *
'*       HEXMAP 4.51              *
'*                               *
'*********************************
'Wargame map making utility program.
'Created by Thomas A. Stevenson (thomas99@phenixcable.net) on 11//00 using
'Future.Library 3.5 created by Michael Rye Sorensen and Jordon Chamid
'
'The end object of this program is to create a series of BMP files
'that can be edited in Paint into a attractive play map for use in
'a hex based wargame.

'Note 800X600 screen resolution is hardwired into the program

'There are modes for adding terrain, roads, and rivers
'The spacebar or menu can be used to change mode

'Right click inside the map to bring up the tile selctor
'(while in Tile mode)
'Right click on tile in the tile selector to edit it
'At start all terrain is set to type 1

'Click between squares to add rivers or roads
'in the approiate mode

'Roads and rivers can be removed by right clicking between
'squares in the approiate mode.

'Scrolling can be done by keyboard or by clicking on the scrollbars

'F9 (Or FILE:Save BMP) writes out the map as a series of 800X600 BMP files
'In the order down then right
'
'Send your comments and questions to thomas99@phenixcable.net

DECLARE SUB MapDefault (mapname$)
DECLARE SUB MapGrain ()
DECLARE SUB CalcHexside (col%, row%, col2%, row2%, ox%, oy%, DIR%, DIR2%)
DECLARE SUB RoadDir (rx1%, ry1%, rx2%, ry2%, side%)
DECLARE SUB Map2Scrn (mapX%, mapY%, offX%, offY%, scrnX%, scrnY%)
DECLARE SUB HexSides (hx1%, hy1%, side%, rx1%, ry1%, rx2%, ry2%)
DECLARE SUB Check4Quit (QUIT%)
DECLARE FUNCTION GETINKEY% ()
DECLARE SUB MESSAGE (msg$, secs%)
DECLARE SUB EditString (s$, m$, keyc%, X%, Y%)
DECLARE FUNCTION FormatInt$ (num%, length%)
DECLARE FUNCTION KEYCODEX% ()
DECLARE FUNCTION HexNumber$ (mx%, my%, n%())
DECLARE SUB MapNumbering (MapNumK%())
DECLARE SUB ColorsEdit (mapfile$)
DECLARE SUB TileSave (nt%)
DECLARE SUB TileSelect (c%)
DECLARE SUB TileLoad (m$)
DECLARE SUB TileEdit (orginalData%())
DECLARE SUB ColorPalLoad (PD%())
DECLARE SUB MapCellSize ()
DECLARE SUB MapNamed (m$)
DECLARE SUB MapSize ()
DECLARE SUB GetPath (drive$, pp$)
DECLARE FUNCTION EXIST% (file$)
DECLARE SUB ShiftStatus (status%)
DECLARE SUB MapClear (X%, Y%)
DECLARE SUB Check4Save (m$)
DECLARE SUB MouseUpdate (row%, col%, HY%, HX%)
DECLARE SUB PrgStart ()
DECLARE SUB MapINFO (m$)
DECLARE SUB BMPsave ()
DECLARE SUB Credits ()
DECLARE SUB Alert (Text$(), B$(), X%, Y%, R%)
DECLARE SUB MenuMake ()
DECLARE SUB MenuGet (tmenu%)
DECLARE SUB BMPdraw (X%, Y%, n%)
DECLARE SUB MapSave (m$)
DECLARE SUB MapLoad (m$)
DECLARE SUB MapDraw (Sx%, Sy%, X%, Y%)
DECLARE SUB ModeRiver (X%, Y%, col%, row%)
DECLARE SUB ModeRoad (X%, Y%, col%, row%)
DECLARE FUNCTION BIN$ (n%)
DECLARE FUNCTION CalcDir% (R1%, C1%, r2%, C2%)
DECLARE FUNCTION ADJACENT% (X1%, Y1%, x2%, y2%)
DECLARE FUNCTION INBOX% (X%, Y%, X1%, Y1%, x2%, y2%)
DECLARE FUNCTION MAX% (V1%, V2%)
DECLARE FUNCTION MIN% (V1%, V2%)
DECLARE SUB setcolors ()

TYPE RegTypeX
  ax    AS INTEGER
  bx    AS INTEGER
  cx    AS INTEGER
  dx    AS INTEGER
  bp    AS INTEGER
  si    AS INTEGER
  di    AS INTEGER
  flags AS INTEGER
  ds    AS INTEGER
  es    AS INTEGER
END TYPE
DECLARE SUB InterruptX (intnum%, inreg AS RegTypeX, outreg AS RegTypeX)

REM $INCLUDE: 'future.bi'
REM $DYNAMIC
DEFINT A-Z

  '********************* KeyBoard Constants ****************
  CONST LEFT = 1075, RIGHT = 1077, PGDN = 1081, PGUP = 1073
  CONST UP = 1072, DOWN = 1080, ESC = 27, TABKEY = 9, CR = 13
  CONST HOME = 1071, ENDKEY = 1079, INSERT = 1082, DELETE = 1083
  CONST BACKSPACE = 8, SHFTTAB = 1015
  '****************  Color Constants ************************
  CONST BLACK = 0, WHITE = 4, RED = 3, DGREEN = 2, GREEN = 5, LTGREEN = 1
  CONST DBLUE = 6, BLUE = 7, LTBLUE = 8, LtGray = 9, GRAY = 10, DrGray = 11
  CONST YELLOW = 12, LTBROWN = 13, BROWN = 14
  CONST HexCOLOR = 200, NumberCOLOR = 201, CenterDotCOLOR = 202
  CONST Rd1COLOR = 203, Rd2COLOR = 204, Rv1COLOR = 205
  CONST Rv2COLOR = 206

  '************************ Logical Constants *******************
  CONST TRUE = -1, FALSE = 0
  '********************** Map Constants **************************
  '** Viewport size in pixels
  CONST px1 = 10, py1 = 100, px2 = 780, py2 = 540
  '** scroll constants in pixels
  CONST bigstep = py2 - py1 - 10, smallstep = 40

  CONST SLIDERW = 6     '** Slider thickness
  CONST THICKNESS = 2   '** For roads and rivers
   
  COMMON SHARED Workscreen, Page
  COMMON SHARED mouseposY, mouseposX, LMousebutton, RMousebutton
  COMMON SHARED HexNumbers, CenterDots, HEXs, aHex
  COMMON SHARED TotalX, TotalY, cellsizeX, cellsizeY
  COMMON SHARED MaxX, MaxY, Ysize, Xsize, UPDOWN
  COMMON SHARED mode, maxTiles, mapname$, nTiles, tileXMShand()
   
  DIM SHARED map(1, 1), road(1, 1), river(1, 1)
  DIM SHARED DAT(10)
  DIM SHARED nSubm(6), submenu(6, 6)  AS STRING * 12
  DIM SHARED PalDATA(255, 2), tileXMShand(200)
  DIM SHARED ry(2), rx(2)
  DIM SHARED MapNumK(5)

  nModes = 5: mode = 1: ModePos = 700
  cTile = 1
  UPDOWN = TRUE

  IF IsXMSInstalled = 0 THEN CLS : PRINT "NO XMS": END
  Set800x600 8   'Set  svga screen
  Workscreen = AllocateXMS(480000)
  SLEEP 1         'Give video a chance to reset

  maxTiles = 200
 
  IF EXIST("default.map") THEN
    f = FREEFILE
    OPEN "default.map" FOR INPUT AS #f
    INPUT #1, mapname$
    CLOSE f
  ELSE
    mapname$ = "maptiles"           '** File name for loading/saving map
  END IF

  CALL setcolors
  CALL MapLoad(mapname$)
  CALL TileLoad(mapname$)
  CALL MenuMake
  CALL PrgStart
  Future.PRINT ModePos, 0, " " + submenu(2, mode), BLACK, WHITE
  CALL MouseUpdate(row, col, HY, HX)
  CALL Credits

  '***** Main control loop
  DO
     
    Future.UpdateMouse      'update mouse
    CALL MouseUpdate(row, col, HY, HX)
    GOSUB GetEvent
    SELECT CASE event
    CASE 1 '*****  MOUSE IN MAP AREA
      SELECT CASE mode
      CASE 1   '**  Terrean mode
        IF LMousebutton AND INBOX(col, row, 0, 0, TotalX - 1, TotalY - 1) THEN
          map(col, row) = cTile
          MapDraw col, row, HX, HY
        ELSEIF RMousebutton THEN
          cTile = map(col, row)
          CALL TileSelect(cTile)
          'MapDraw -99, -99, HX, HY
        END IF
      CASE 2, 3
        ModeRoad HX, HY, col, row
      CASE 4, 5'** River Mode
        ModeRiver HX, HY, col, row
        MapDraw col, row, HX, HY
      END SELECT
    CASE 2 '*********** LEFT  MOUSE in Terrean selection area
      cTile = map(col, row)
      CALL TileSelect(cTile)
    CASE 3
      '*** Vertical slider event
      '*** Calc Slider size =%visual of total vertical
      ww! = (py2 - py1) / (cellsizeY * TotalY) * (py2 - py1)
      '** Calc current slider position
      Vpos = py1 + ((py2 - py1 - ww!) / MaxY) * HY
      '** was click above or below slider?
      IF mouseposY < Vpos THEN HY = HY - bigstep
      IF mouseposY > Vpos + ww! THEN HY = HY + bigstep
    CASE 4
      '*** Horizontial slider event
      ww! = (px2 - px1) / (cellsizeX * TotalX) * (px2 - px1)
      Hpos = px1 + ((px2 - px1 - ww!) / MaxX) * HX
      IF mouseposX < Hpos THEN HX = HX - bigstep
      IF mouseposX > Hpos + ww! THEN HX = HX + bigstep
    END SELECT

    '*** Get keyboard input and scroll map
    t$ = INKEY$
    t = LEN(t$)
    IF t = 0 THEN
      keyc = -1
    ELSEIF t = 1 THEN
      keyc = ASC(t$)
    ELSEIF t = 2 THEN
      keyc = 1000 + ASC(MID$(t$, 2, 1))
    END IF
   
    SELECT CASE keyc
    CASE -1
      'do nothing
    CASE ESC
      QUIT = TRUE
    CASE HOME
      HY = 0: HX = 0
    CASE ENDKEY
      HY = MaxY: HX = MaxX
    CASE PGDN
      HY = HY + bigstep
    CASE PGUP
      HY = HY - bigstep
    CASE INSERT
    CASE DELETE
    CASE UP
      HY = HY - smallstep
    CASE DOWN
      HY = HY + smallstep
    CASE RIGHT
      HX = HX + smallstep
    CASE LEFT
      HX = HX - smallstep
    CASE TABKEY
      HX = HX + bigstep
    CASE SHFTTAB
      HX = HX - bigstep
    CASE 32 'space
      mode = mode + 1: IF mode > nModes THEN mode = 1
      Future.PRINT ModePos, 0, " " + submenu(2, mode), BLACK, WHITE
    CASE 1063  'F5
      CALL MapClear(HX, HY)
    CASE 1064 'F6
      '** Load
      CALL MapLoad(mapname$)
      CALL TileLoad(mapname$)
      CALL MapDraw(-99, -99, HX, HY)
    CASE 1065 'F7
      '** Save
      MapSave mapname$
    CASE 1066 'F8
      '** Save BMP
      CALL BMPsave
    CASE ELSE
      'Future.PRINT 700, 20, "Key = " + RIGHT$("0000" + STR$(keyc), 4) + "  ", WHITE, 0
    END SELECT

    HX = MAX(0, MIN(HX, MaxX))
    HY = MAX(0, MIN(HY, MaxY))

    IF oldx <> HX OR oldy <> HY THEN
      '********** Update Screen
      oldx = HX
      oldy = HY
      CALL MapDraw(-99, -99, HX, HY)
    END IF
    IF QUIT THEN
      CALL Check4Quit(QUIT)
    END IF
  LOOP UNTIL QUIT

  '*** Clean-up and exit
  CALL Check4Save(mapname$)
  Future.MouseOff
  DeallocateXMS Workscreen 'free up XMS memory
  FOR i = 1 TO nTiles
    DeallocateXMS tileXMShand(i)
  NEXT i

  ReSetScreen
  END

GetEvent:
   
  event = 0
  RMousebutton = Future.MouseB AND 2
  LMousebutton = Future.MouseB AND 1
  IF LMousebutton OR RMousebutton THEN
    IF INBOX(mouseposX, mouseposY, px1, py1, px2, py2) THEN
      event = 1 '** mouse down in map area
    ELSEIF INBOX(mouseposX - px2, mouseposY, 10, py1, 10 + cellsizeX, py1 + 9 * cellsizeY + 80) THEN
      'Mouse in tile selector area
      event = 2
    ELSEIF INBOX(mouseposX - px2, mouseposY - py1, 0, 0, SLIDERW, py2) THEN
      'Mouse down in Vertical slider area
      event = 3
    ELSEIF INBOX(mouseposX - px1, mouseposY - py2, 0, 0, px2, SLIDERW) THEN
      'Mouse down in Horizontial slider area
      event = 4
    ELSEIF INBOX(mouseposX, mouseposY, 0, 0, nSubm(0) * 80, 16) THEN
      choice = MIN(mouseposX / 80 + 1, nSubm(0))
      CALL MenuGet(choice)
      SELECT CASE choice
      CASE 11
        CALL Credits
      CASE 12
        CALL MapNamed(mapname$)
        CALL MapLoad(mapname$)
        CALL TileLoad(mapname$)
        CALL MapDraw(-99, -99, HX, HY)
      CASE 13
        MapSave mapname$
      CASE 14
        CALL MapNamed(mapname$)
        MapSave mapname$
        CALL MapDefault(mapname$)
      CASE 15
        CALL BMPsave
      CASE 16
        QUIT = TRUE
      CASE 21
        mode = 1: Future.PRINT ModePos, 0, " " + submenu(2, mode), BLACK, WHITE
      CASE 22
        mode = 2: Future.PRINT ModePos, 0, " " + submenu(2, mode), BLACK, WHITE
      CASE 23
        mode = 3: Future.PRINT ModePos, 0, " " + submenu(2, mode), BLACK, WHITE
      CASE 24
        mode = 4: Future.PRINT ModePos, 0, " " + submenu(2, mode), BLACK, WHITE
      CASE 25
        mode = 5: Future.PRINT ModePos, 0, " " + submenu(2, mode), BLACK, WHITE
      CASE 31
        IF CenterDots = TRUE THEN
          submenu(3, 1) = "Dots are OFF"
          CenterDots = FALSE
        ELSE
          submenu(3, 1) = "Dots are  ON"
          CenterDots = TRUE
        END IF
        CALL MapDraw(-99, -99, HX, HY)
      CASE 32
        IF HEXs = TRUE THEN
          submenu(3, 2) = "HEXs are OFF"
          HEXs = FALSE
        ELSE
          submenu(3, 2) = "HEXs are  ON"
          HEXs = TRUE
        END IF
        CALL MapDraw(-99, -99, HX, HY)
      CASE 33
        IF HexNumbers = TRUE THEN
          submenu(3, 3) = "Nums are OFF"
          HexNumbers = FALSE
        ELSE
          submenu(3, 3) = "HEXs are  ON"
          HexNumbers = TRUE
        END IF
        CALL MapDraw(-99, -99, HX, HY)
      CASE 41
        CALL MapINFO(mapname$)
      CASE 42
        CALL MapSize
      CASE 43
        CALL MapDefault(mapname$)
      CASE 44
        CALL MapClear(HX, HY)
      CASE 45
        CALL ColorsEdit(mapname$)
      CASE 51
        aHex = MIN(aHex + 1, cellsizeX / 2 - 4)
        submenu(5, 3) = "aHex = " + STR$(aHex)
        CALL MapDraw(-99, -99, HX, HY)
      CASE 46
        CALL MapNumbering(MapNumK%())
        CALL MapDraw(-99, -99, HX, HY)
      CASE 52
        aHex = MAX(aHex - 1, 0)
        submenu(5, 3) = "aHex = " + STR$(aHex)
        CALL MapDraw(-99, -99, HX, HY)
      CASE 54
        CALL MapGrain
      CASE 61
        '** select tile
        mz$ = "The tile selection box can also be|"
        mz$ = mz$ + "reached by right clicking inside|"
        mz$ = mz$ + "map area while in add tile mode."
        MESSAGE mz$, 5
        mz$ = ""
        CALL TileSelect(cTile)
      CASE 62
        '** New tile
        IF nTiles < maxTiles THEN
          Bytes = (cellsizeX - 0) * (cellsizeY - 0) + 10
          nTiles = nTiles + 1
          tileXMShand(nTiles) = AllocateXMS(Bytes)
          Future.XMSget 100, 100, 99 + cellsizeX, 99 + cellsizeY, tileXMShand(nTiles)
        END IF
      CASE 63
        '** edit tile
        m$ = "Right click on the tile|you wish to edit."
        MESSAGE m$, 3
        CALL TileSelect(cTile)
      CASE 64
        CALL MapCellSize
        CALL MapDraw(-99, -99, HX, HY)
      CASE ELSE
        'Future.PRINT 500, 0, submenu(INT(choice / 10), choice MOD 10), RED, BLACK
        'Future.PRINT 600, 0, STR$(choice) + "  ", RED, BLACK
      END SELECT
    ELSE
      event = 0
    END IF
  END IF

RETURN


nofile:
RESUME NEXT

REM $STATIC
SUB BMPdraw (X, Y, n)

  Sy = INT(Y / cellsizeY)
  Sx = INT(X / cellsizeX)
  Y1 = MAX(Sy - 1, 0): y2 = MIN(Sy + 600 / cellsizeY, TotalY - 1)
  X1 = MAX(Sx - 1, 0): x2 = MIN(Sx + 800 / cellsizeX, TotalX - 1)

  SetViewPort 0, 0, 800, 600
  Future.CLS 0
 
  '***  Draw Terrain *****
  FOR my = Y1 TO y2
      FOR mx = X1 TO x2
      CALL Map2Scrn(mx, my, X, Y, hx1, hy1)
      Future.XMSput hx1 - px1, hy1 - py1, tileXMShand(map(mx, my))
    NEXT mx
  NEXT my

  '*** DRAW rivers
  FOR my = Y1 TO y2
    FOR mx = X1 TO x2
      IF river(mx, my) > 0 THEN
        CALL Map2Scrn(mx, my, X, Y, hx1, hy1)
        hx1 = hx1 - px1: hy1 = hy1 - py1
        FOR k = 0 TO 1
          c& = Rv2COLOR
          IF k = 1 THEN c& = Rv1COLOR
          testbit = 256 ^ k
        
          FOR side = 1 TO 3
            CALL HexSides(hx1, hy1, side, rx1, ry1, rx2, ry2)
            IF river(mx, my) AND testbit THEN
              FOR i = -THICKNESS TO THICKNESS
                IF ry1 = ry2 THEN
                  Future.LINE rx1, ry1 + i, rx2, ry2 + i, c&, -1
                ELSE
                  Future.LINE rx1 + i, ry1, rx2 + i, ry2, c&, -1
                END IF
              NEXT i
            END IF
            testbit = testbit * 2
          NEXT side
      
        NEXT k
      END IF
    NEXT mx
  NEXT my

  '**** Draw Roads ***************
  FOR my = Y1 TO y2
    FOR mx = X1 TO x2
      IF road(mx, my) > 0 THEN
        CALL Map2Scrn(mx, my, X, Y, hx1, hy1)
        hx1 = hx1 - px1: hy1 = hy1 - py1
        ry1 = hy1 + cellsizeY / 2
        rx1 = hx1 + cellsizeX / 2
        FOR j = 0 TO 1
          testbit = 256 ^ j
          c& = Rd1COLOR
          IF j = 1 THEN c& = Rd2COLOR

          FOR side = 1 TO 3                '** three directions
            IF road(mx, my) AND testbit THEN
              CALL RoadDir(rx1, ry1, rx2, ry2, side)
              IF rx1 = rx2 THEN
                FOR k = -1 TO 1
                  Future.LINE rx1 + k, ry1, rx2 + k, ry2, c&, -1
                NEXT k
              ELSE
                FOR k = -1 TO 1
                  Future.LINE rx1, ry1 + k, rx2, ry2 + k, c&, -1
                NEXT k
              END IF
            END IF
            testbit = testbit * 2
          NEXT side

        NEXT j
      END IF
    NEXT mx
  NEXT my

  IF HexNumbers = TRUE THEN
    cx = (cellsizeX - 32) \ 2
    cy = (cellsizeY - 16) \ 2
    FOR my = Y1 TO y2
      FOR mx = X1 TO x2
        CALL Map2Scrn(mx, my, X, Y, tx, ty)
        tx = tx - px1: ty = ty - py1
        Future.PRINT tx + cx, ty + cy, HexNumber$(mx, my, MapNumK()), NumberCOLOR, -1
      NEXT mx
    NEXT my
  END IF

  IF CenterDots = TRUE THEN
    cx = cellsizeX \ 2 - 1
    cy = cellsizeY \ 2 - 1
    FOR my = Y1 TO y2
      FOR mx = X1 TO x2
        CALL Map2Scrn(mx, my, X, Y, tx, ty)
        tx = tx - px1: ty = ty - py1
        Future.FILLBOX tx + cx, ty + cy, tx + cx + 2, ty + cy + 2, CenterDotCOLOR
      NEXT mx
    NEXT my
  END IF

  IF HEXs = TRUE THEN
    FOR my = Y1 TO y2
      FOR mx = X1 TO x2
        CALL Map2Scrn(mx, my, X, Y, hx1, hy1)
        hx1 = hx1 - px1: hy1 = hy1 - py1
        FOR side = 1 TO 3
          CALL HexSides(hx1, hy1, side, rx1, ry1, rx2, ry2)
          Future.LINE rx1, ry1, rx2, ry2, HexCOLOR, -1
        NEXT side
      NEXT mx
    NEXT my
  END IF
 
  t$ = "Screen" + RIGHT$("0" + LTRIM$(STR$(n)), 2) + ".bmp"
  Future.SNAPSHOT t$
  Future.PRINT 0, 0, t$, RED, -1

  WHILE INKEY$ = "": WEND

END SUB

SUB BMPsave
  'GOTO skip
  IF CenterDots OR HEXs OR HexNumbers THEN
    DIM t$(10), B$(3)

    t$(1) = "I Recommend saving the BMP files without"
    t$(2) = "hex numbers, center dots or hex sides since"
    t$(3) = "they can be added later under program"
    t$(4) = "control and it makes editing the BMP file"
    t$(5) = "much easier."
    t$(6) = ""
    t$(7) = "PROCEED with current settings, turn numbers,"
    t$(8) = "Turn numbers, dots, and hexes OFF & continue,"
    t$(9) = "or CANCEL"

    B$(1) = "PROCEED"
    B$(2) = "  OFF  "
    B$(3) = "CANCEL "

    CALL Alert(t$(), B$(), 0, 0, c)
    IF c = 3 THEN EXIT SUB
    IF c = 2 THEN
      submenu(3, 1) = "Dots are OFF": CenterDots = FALSE
      submenu(3, 2) = "HEXs are OFF": HEXs = FALSE
      submenu(3, 3) = "Nums are OFF": HexNumbers = FALSE
    END IF
  END IF


  Future.MouseOff  '** Hide mouse while we draw to screen
  Future.XMSget 0, 0, 800, 600, Workscreen
  FOR bx = 0 TO TotalX * cellsizeX STEP 800
    FOR by = 0 TO TotalY * cellsizeY STEP 600
      IF bx = TotalX * cellsizeX THEN
      ELSEIF by = TotalY * cellsizeY THEN
      ELSE
        ScreenNum = ScreenNum + 1
        BMPdraw bx, by, ScreenNum
      END IF
    NEXT by
  NEXT bx
  Future.XMSput 0, 0, Workscreen
  SetViewPort 0, 0, 800, 600
  Future.MouseOn
skip:
  REDIM t$(12), B$(1)

  t$(1) = "The map has been save as a series of BMP"
  t$(2) = "files in the default directory under the"
  t$(3) = "name of screen##.bmp.      "
  t$(4) = ""
  t$(5) = "The companion program BMPMAP demonstrates  "
  t$(6) = "how to load and use the BMP files, but make"
  t$(7) = "sure the map constants are the same!"
  t$(8) = ""
  t$(9) = "Ideally the BMP files should be edited in  "
  t$(10) = "a Paint Program into a more attractive"
  t$(11) = "format prior to use."

  B$(1) = " OK "

  CALL Alert(t$(), B$(), 0, 0, c)

END SUB

SUB Check4Quit (QUIT)
  DIM t$(4), B$(2)

  t$(1) = "       Hex Map Maker       "
  t$(2) = " Are sure you want to quit "

  B$(1) = "CANCEL"
  B$(2) = " QUIT "


  CALL Alert(t$(), B$(), 0, 0, c)
  IF c = 1 THEN QUIT = FALSE

END SUB

SUB Check4Save (m$)

  CHANGED = FALSE
  j = 20
  FOR Y = 0 TO TotalY - 1
    FOR X = 0 TO TotalX - 1
      j = j + 1: IF DAT(j) XOR map(X, Y) THEN CHANGED = TRUE
      j = j + 1: IF DAT(j) XOR road(X, Y) THEN CHANGED = TRUE
      j = j + 1: IF DAT(j) XOR river(X, Y) THEN CHANGED = TRUE
      IF CHANGED THEN
        DIM t$(4), B$(2)

        t$(1) = "Map Data has changed since last "
        t$(2) = "Save or Load!"
        t$(3) = "Save Data now?"

        B$(1) = " SAVE  "
        B$(2) = "NO SAVE"
           
        CALL Alert(t$(), B$(), 0, 0, c)
        IF c = 1 THEN MapSave m$
        EXIT SUB
      END IF
    NEXT X
  NEXT Y

END SUB

SUB ColorsEdit (mapfile$)
  Future.MouseOff  '** Hide mouse while we draw to screen
  Future.XMSget 0, 0, 799, 599, Workscreen
 
  CALL ColorPalLoad(PalDATA())
  '** copy Palette indexes into arry
  DIM eColors&(6)
  eColors&(0) = CenterDotCOLOR
  eColors&(1) = NumberCOLOR
  eColors&(2) = HexCOLOR
  eColors&(3) = Rd1COLOR
  eColors&(4) = Rd2COLOR
  eColors&(5) = Rv1COLOR
  eColors&(6) = Rv2COLOR
  DIM c&(2)
  c&(0) = RED
  c&(1) = GREEN
  c&(2) = BLUE

  bx = 200: by = 200: bw = 300: bh = 200
  Future.FILLBOX bx, by, bx + bw, by + bh, BLACK
  bx2 = bx + 10: by2 = by + 10
  Future.PRINT bx2, by2 + 0, "CenterDot  ", WHITE, BLACK
  Future.PRINT bx2, by2 + 20, "Hex Numbers", WHITE, BLACK
  Future.PRINT bx2, by2 + 40, "Hexsides   ", WHITE, BLACK
  Future.PRINT bx2, by2 + 60, "Road1      ", WHITE, BLACK
  Future.PRINT bx2, by2 + 80, "Road2      ", WHITE, BLACK
  Future.PRINT bx2, by2 + 100, "River1     ", WHITE, BLACK
  Future.PRINT bx2, by2 + 120, "River2     ", WHITE, BLACK

  '** Draw color entries
  bx3 = bx2 + 100
  FOR i = 0 TO 6
    Y = by2 + i * 20
    FOR k = 0 TO 2
      t$ = RIGHT$(" " + STR$(PalDATA(eColors&(i), k)), 3)
      Future.PRINT bx3 + k * 30, Y, t$, WHITE, c&(k)
    NEXT k
    Future.FILLBOX bx3 + 120, Y + 1, bx3 + 140, Y + 19, eColors&(i)
  NEXT i

  '**  Draw Change Buttons
  by3 = by2 + 145: bx4 = bx3 - 40
  Future.PRINT bx4 + 0, by3, " 0 ", RED, WHITE
  Future.PRINT bx4 + 30, by3, "-10", RED, WHITE
  Future.PRINT bx4 + 60, by3, " -1", RED, WHITE
  Future.PRINT bx4 + 90, by3, " +1", RED, WHITE
  Future.PRINT bx4 + 120, by3, "+10", RED, WHITE
  Future.PRINT bx4 + 150, by3, " 63", RED, WHITE

  Future.PRINT bx + bw - 110, by + bh - 20, "SAVE & EXIT", WHITE, RED
  Future.PRINT bx + 20, by + bh - 20, "CANCEL", WHITE, RED

  Future.MouseOn
  i = 0: k = 0
  X = bx3 + k * 30
  Y = by2 + i * 20
  DO
    Future.UpdateMouse
    IF Future.MouseB AND 1 THEN
      mx = Future.MouseX
      my = Future.MouseY
      IF INBOX(mx, my, bx3, by2, bx3 + 90, by2 + 140) THEN
        Future.MouseOff
        t$ = RIGHT$(" " + STR$(PalDATA(eColors&(i), k)), 3)
        Future.PRINT X, Y, t$, WHITE, c&(k)

        i = MIN((my - by2) \ 20, 6)
        k = MIN((mx - bx3) \ 30, 2)
        X = bx3 + k * 30
        Y = by2 + i * 20
        t$ = RIGHT$(" " + STR$(PalDATA(eColors&(i), k)), 3)
        Future.PRINT X, Y, t$, c&(k), WHITE
        Future.MouseOn
        DO: Future.UpdateMouse: LOOP UNTIL Future.MouseB = 0

      ELSEIF INBOX(mx, my, bx4, by3, bx4 + 180, by3 + 16) THEN
        pick = (mx - bx4) \ 30
        e = eColors&(i)
        SELECT CASE pick
        CASE 0 '0
          PalDATA(e, k) = 0
        CASE 1 '-10
          PalDATA(e, k) = MAX(PalDATA(e, k) - 10, 0)
        CASE 2 '-1
          PalDATA(e, k) = MAX(PalDATA(e, k) - 1, 0)
        CASE 3 '+1
          PalDATA(e, k) = MIN(PalDATA(e, k) + 1, 63)
        CASE 4 '+10
          PalDATA(e, k) = MIN(PalDATA(e, k) + 10, 63)
        CASE 5  '63
          PalDATA(e, k) = 63
        END SELECT
        ChangePal e, PalDATA(e, 0), PalDATA(e, 1), PalDATA(e, 2)
        t$ = RIGHT$(" " + STR$(PalDATA(e, k)), 3)
        Future.PRINT X, Y, t$, c&(k), WHITE
        DO: Future.UpdateMouse: LOOP UNTIL Future.MouseB = 0
      ELSEIF INBOX(mx, my, bx + bw - 110, by + bh - 20, bx + bw, by + bh) THEN
        m$ = mapfile$ + ".pal"
        SavePal m$
        MESSAGE "Pallete saved to |" + m$, 3
        DONE = TRUE
      ELSEIF INBOX(mx, my, bx + 20, by + bh - 20, bx + 70, by + bh) THEN
        LoadPal "tempPAL.txt"
        DONE = TRUE
      END IF
    ELSEIF Future.MouseB = 2 THEN
      DONE = TRUE
    END IF
  LOOP UNTIL DONE

  '** Clear input buffers
  DO: Future.UpdateMouse: LOOP UNTIL Future.MouseB = 0
  DO: LOOP UNTIL INKEY$ = ""

  Future.MouseOff
  Future.XMSput 0, 0, Workscreen
  Future.MouseOn

END SUB

SUB MapClear (X, Y)

  DIM t$(4), B$(2)

  t$(1) = "Are you sure you want to"
  t$(2) = "Clear the map of terrain"
  t$(3) = "roads and rivers ?"

  B$(1) = "CLEAR "
  B$(2) = "CANCEL"
       
  CALL Alert(t$(), B$(), 0, 0, c)
  IF c = 1 THEN
    FOR ty = 0 TO TotalY - 1
      FOR tx = 0 TO TotalX - 1
        map(tx, ty) = 1
        road(tx, ty) = 0
        river(tx, ty) = 0
      NEXT tx
    NEXT ty
  END IF
  CALL MapDraw(-99, -99, HX, HY)

END SUB

SUB MapDraw (Sx, Sy, X, Y)
 
  Future.MouseOff  '** Hide mouse while we draw to screen
  Future.XMSget 0, 0, 799, 599, Workscreen
  Page = Page XOR 1
  SetPage Page
  Future.XMSput 0, 0, Workscreen
  SetViewPort px1, py1, px2, py2
 
  IF Sx = -99 THEN
    Sy = INT(Y / cellsizeY)
    Sx = INT(X / cellsizeX)
    Y1 = MAX(Sy - 1, 0): y2 = MIN(Sy + Ysize, TotalY - 1)
    X1 = MAX(Sx - 1, 0): x2 = MIN(Sx + Xsize, TotalX - 1)
    Future.CLS BLACK
    GOSUB PutTiles
    GOSUB DrawMapFeatures
    GOSUB DrawSliders
  ELSE
    '***  Draw Terrain in Target square and all adacent squares
    Y1 = MAX(Sy - 1, 0): y2 = MIN(Sy + 1, TotalY - 1)
    X1 = MAX(Sx - 1, 0): x2 = MIN(Sx + 1, TotalX - 1)
    GOSUB PutTiles
    '** need to expand drawing area because puttiles
    '** erase hexsides two tiles out
    '** could use setviewport instead
    Y1 = MAX(Y1 - 1, 0): y2 = MIN(y2 + 1, TotalY - 1)
    X1 = MAX(X1 - 1, 0): x2 = MIN(x2 + 1, TotalX - 1)
    GOSUB DrawMapFeatures
  END IF
 
  SetViewPort 0, 0, 800, 600
  ViewPage Page
  Future.MouseOn

EXIT SUB

PutTiles:
  FOR my = Y1 TO y2
      FOR mx = X1 TO x2
      CALL Map2Scrn(mx, my, X, Y, hx1, hy1)
      Future.XMSput hx1, hy1, tileXMShand(map(mx, my))
    NEXT mx
  NEXT my
RETURN

DrawMapFeatures:
  '*** DRAW rivers
  FOR my = Y1 TO y2
    FOR mx = X1 TO x2
      IF river(mx, my) > 0 THEN
        CALL Map2Scrn(mx, my, X, Y, hx1, hy1)
        FOR k = 0 TO 1
          c& = Rv2COLOR
          IF k = 1 THEN c& = Rv1COLOR
          testbit = 256 ^ k
        
          FOR side = 1 TO 3
            CALL HexSides(hx1, hy1, side, rx1, ry1, rx2, ry2)
            IF river(mx, my) AND testbit THEN
              FOR i = -THICKNESS TO THICKNESS
                IF ry1 = ry2 THEN
                  Future.LINE rx1, ry1 + i, rx2, ry2 + i, c&, -1
                ELSE
                  Future.LINE rx1 + i, ry1, rx2 + i, ry2, c&, -1
                END IF
              NEXT i
            END IF
            testbit = testbit * 2
          NEXT side
      
        NEXT k
      END IF
    NEXT mx
  NEXT my

  '**** Draw Roads ***************
  FOR my = Y1 TO y2
    FOR mx = X1 TO x2
      IF road(mx, my) > 0 THEN
        CALL Map2Scrn(mx, my, X, Y, hx1, hy1)
        ry1 = hy1 + cellsizeY / 2
        rx1 = hx1 + cellsizeX / 2
        FOR j = 0 TO 1
          testbit = 256 ^ j
          c& = Rd1COLOR
          IF j = 1 THEN c& = Rd2COLOR

          FOR side = 1 TO 3                '** three directions
            IF road(mx, my) AND testbit THEN
              CALL RoadDir(rx1, ry1, rx2, ry2, side)
              IF rx1 = rx2 THEN
                FOR k = -1 TO 1
                  Future.LINE rx1 + k, ry1, rx2 + k, ry2, c&, -1
                NEXT k
              ELSE
                FOR k = -1 TO 1
                  Future.LINE rx1, ry1 + k, rx2, ry2 + k, c&, -1
                NEXT k
              END IF
            END IF
            testbit = testbit * 2
          NEXT side

        NEXT j
      END IF
    NEXT mx
  NEXT my

  IF HexNumbers = TRUE THEN
    cx = (cellsizeX - 32) \ 2
    cy = (cellsizeY - 16) \ 2
    FOR my = Y1 TO y2
      FOR mx = X1 TO x2
        CALL Map2Scrn(mx, my, X, Y, tx, ty)
        Future.PRINT tx + cx, ty + cy, HexNumber$(mx, my, MapNumK()), NumberCOLOR, -1
      NEXT mx
    NEXT my
  END IF

  IF CenterDots = TRUE THEN
    cx = cellsizeX \ 2 - 1
    cy = cellsizeY \ 2 - 1
    FOR my = Y1 TO y2
      FOR mx = X1 TO x2
        CALL Map2Scrn(mx, my, X, Y, tx, ty)
        Future.FILLBOX tx + cx, ty + cy, tx + cx + 2, ty + cy + 2, CenterDotCOLOR
      NEXT mx
    NEXT my
  END IF

  IF HEXs = TRUE THEN
    FOR my = Y1 TO y2
      FOR mx = X1 TO x2
        CALL Map2Scrn(mx, my, X, Y, hx1, hy1)
        FOR side = 1 TO 3
          CALL HexSides(hx1, hy1, side, rx1, ry1, rx2, ry2)
          Future.LINE rx1, ry1, rx2, ry2, HexCOLOR, -1
        NEXT side
      NEXT mx
    NEXT my
  END IF
RETURN

DrawSliders:
  SetViewPort 0, 0, 800, 600
  '** Draw Sliders
  Future.FILLBOX px2, py1, px2 + SLIDERW, py2, WHITE
  ww! = (py2 - py1) / (cellsizeY * TotalY) * (py2 - py1)
  Vpos = py1 + ((py2 - py1 - ww!) / MaxY) * Y
  Future.FILLBOX px2, Vpos, px2 + SLIDERW, Vpos + ww!, RED

  Future.FILLBOX px1, py2, px2, py2 + SLIDERW, WHITE
  ww! = (px2 - px1) / (cellsizeX * TotalX) * (px2 - px1)
  Hpos = px1 + ((px2 - px1 - ww!) / MaxX) * X
  Future.FILLBOX Hpos, py2, Hpos + ww!, py2 + SLIDERW, RED
RETURN

END SUB

SUB MapINFO (m$)
   
    DIM t$(5), B$(1)

    CALL GetPath("C", pp$)
    t$(1) = "Current Path = C:\" + pp$
    t$(2) = "Map File Name = " + m$
    t$(3) = "Map Size:       " + STR$(TotalX) + " by" + STR$(TotalY)
    t$(4) = "Tile Size:      " + STR$(cellsizeX) + " by" + STR$(cellsizeY)

    B$(1) = "  OK  "

    CALL Alert(t$(), B$(), 0, 0, c)


END SUB

SUB MapLoad (m$)
  
  drive$ = "C"
  CALL GetPath(drive$, pp$)
  mapdata$ = m$ + ".bin"

 
  IF EXIST%(mapdata$) THEN
    f = FREEFILE
    OPEN mapdata$ FOR RANDOM AS f
    Bytes = LOF(f)
    CLOSE f
    TotalWords = (Bytes - 7) / 2
    REDIM DAT(1 TO TotalWords)

    IF FALSE THEN
      DIM t$(4), B$(1)

      t$(1) = "Map Data File too Large"
      t$(2) = drive$ + ":\" + pp$ + "\" + mapdata$
      t$(3) = "Starting with blank Map"

      B$(1) = "  OK  "
             
      CALL Alert(t$(), B$(), 0, 0, c)
      'Map has been reduced in size and BLOADing old larger
      'map data would corrupt memory so map is in effect cleared
      'instead
    ELSE
     
      DEF SEG = VARSEG(DAT(1))
      BLOAD mapdata$, VARPTR(DAT(1))
      DEF SEG
    END IF
  ELSE
    DIM t$(4), B$(1)
    t$(1) = "Map Data File Not Found"
    t$(2) = drive$ + ":\" + pp$ + "\" + mapdata$
    t$(3) = "Starting with blank Map"
    B$(1) = "  OK  "
    CALL Alert(t$(), B$(), 0, 0, c)
    GOTO blankmap
  END IF

  TotalX = DAT(1)
  TotalY = DAT(2)
  cellsizeX = DAT(3)
  cellsizeY = DAT(4)
  MapNumK(1) = DAT(5)    'Y offset
  MapNumK(2) = DAT(6)    'Y multipler
  MapNumK(3) = DAT(7)    'even row column offset
  MapNumK(4) = DAT(8)    'odd row column offset
  MapNumK(5) = DAT(9)    'Column multiplier
  HexNumbers = DAT(10)
  CenterDots = DAT(11)
  HEXs = DAT(12)
  aHex = DAT(13)
  nTiles = DAT(14)
  UPDOWN = DAT(15)
 
  '** critical map variables that must be non-zero
  IF TotalX = 0 THEN TotalX = 20
  IF TotalY = 0 THEN TotalY = 20
  IF cellsizeX = 0 THEN cellsizeX = 50
  IF cellsizeY = 0 THEN cellsizeY = 50
  IF MapNumK(1) = 0 THEN MapNumK(1) = 100
  IF MapNumK(5) = 0 THEN MapNumK(5) = 100
  IF nTiles = 0 THEN nTiles = 9
 
  MaxX = cellsizeX * TotalX - (px2 - px1)
  MaxY = cellsizeY * TotalY - (py2 - py1)
  '** to avoid having blank 1/2 cells on right or bottom edge
  IF UPDOWN THEN
    MaxY = MaxY - cellsizeY \ 2
  ELSE
    MaxX = MaxX - cellsizeX \ 2
  END IF
  Ysize = (py2 - py1) / cellsizeY + 1
  Xsize = (px2 - px1) / cellsizeX + 1

  REDIM map(TotalX - 1, TotalY - 1)
  REDIM road(TotalX - 1, TotalY - 1)
  REDIM river(TotalX - 1, TotalY - 1)

  i = 20
  FOR Y = 0 TO TotalY - 1
    FOR X = 0 TO TotalX - 1
      i = i + 1: map(X, Y) = DAT(i)
      i = i + 1: road(X, Y) = DAT(i)
      i = i + 1: river(X, Y) = DAT(i)
    NEXT X
  NEXT Y
 

EXIT SUB

blankmap:

  '** map size in squares
  TotalX = 32: TotalY = 24
  '** Size of square (hex) in pixels
  cellsizeX = 50: cellsizeY = 50
  MaxX = cellsizeX * TotalX - (px2 - px1)
  MaxY = cellsizeY * TotalY - (py2 - py1)
  Ysize = (py2 - py1) / cellsizeY + 1
  Xsize = (px2 - px1) / cellsizeX + 1
  '** Number system and # of tiles
  MapNumK(1) = 100
  MapNumK(5) = 100
  nTiles = 2
 

  REDIM DAT(TotalX * TotalY + 20)
  REDIM map(TotalX - 1, TotalY - 1)
  REDIM road(TotalX - 1, TotalY - 1)
  REDIM river(TotalX - 1, TotalY - 1)


  '** Default data
  FOR Y = 0 TO TotalY - 1
    FOR X = 0 TO TotalX - 1
      map(X, Y) = 1
      road(X, Y) = 0
      river(X, Y) = 0
    NEXT X
  NEXT Y
 
  MapNumK(1) = 0    'Y offset
  MapNumK(2) = 100  'Y multipler
  MapNumK(3) = 0    'even row column offset
  MapNumK(4) = 0    'odd row column offset
  MapNumK(5) = 1    'Column multiplier
  aHex = 6
  HexNumbers = TRUE
  CenterDots = FALSE
  HEXs = TRUE

END SUB

SUB MapSave (m$)
  TotalWords = 20 + TotalX * TotalY * 3
  REDIM DAT(1 TO TotalWords)

  DAT(1) = TotalX
  DAT(2) = TotalY
  DAT(3) = cellsizeX
  DAT(4) = cellsizeY
  DAT(5) = MapNumK(1)   'Y offset
  DAT(6) = MapNumK(2)   'Y multipler
  DAT(7) = MapNumK(3)   'even row column offset
  DAT(8) = MapNumK(4)   'odd row column offset
  DAT(9) = MapNumK(5)   'Column multiplier
  DAT(10) = HexNumbers
  DAT(11) = CenterDots
  DAT(12) = HEXs
  DAT(13) = aHex
  DAT(14) = nTiles
  DAT(15) = UPDOWN
  '** Reserved for future use
  DAT(16) = 0
  DAT(17) = 0
  DAT(18) = 0
  DAT(19) = 0
  DAT(20) = 0

  i = 20
  FOR Y = 0 TO TotalY - 1
    FOR X = 0 TO TotalX - 1
      i = i + 1: DAT(i) = map(X, Y)
      i = i + 1: DAT(i) = road(X, Y)
      i = i + 1: DAT(i) = river(X, Y)
    NEXT X
  NEXT Y
 
  mapdata$ = m$ + ".bin"
  DEF SEG = VARSEG(DAT(1))
  BSAVE mapdata$, VARPTR(DAT(1)), TotalX * TotalY * 6 + 40
  DEF SEG

  psave$ = m$ + ".pal"
  CALL SavePal(psave$)
  CALL TileSave(nTiles)
  MESSAGE "       Map saved      |  MapData= " + mapdata$ + "|  PalData= " + psave$, 3

END SUB

SUB MapSize
  SetViewPort 0, 0, 800, 600
  Future.MouseOff
  Future.XMSget 0, 0, 800, 600, Workscreen

  bx = 300: by = 200: w = 300: H = 100
  Future.FILLBOX bx, by, bx + w, by + H, BLACK
  Future.FILLBOX bx + 2, by + 2, bx + w - 2, by + H - 2, RED
  Future.PRINT bx + 20, by + 1 * 16, "Input Map Size in Cells", WHITE, RED
  Future.PRINT bx + 40, by + 3 * 16, "X Size:", WHITE, RED
  Future.PRINT bx + 40, by + 4 * 16, "Y Size", WHITE, RED
  t2$ = FormatInt$(TotalY, 4)
  Future.PRINT bx + 90, by + 4 * 16, t2$, WHITE, RED

  '***  Get New Map Size
  t1$ = FormatInt$(TotalX, 4)
  k = 0
  CALL EditString(t1$, "0123456789", k, bx + 40 + 50, by + 3 * 16)
  Future.PRINT bx + 90, by + 3 * 16, t1$, WHITE, RED
  k = 0
  Future.PRINT bx + 90, by + 4 * 16, SPACE$(4), WHITE, RED
  CALL EditString(t2$, "0123456789", k, bx + 40 + 50, by + 4 * 16)

  t1 = VAL(t1$)
  t2 = VAL(t2$)
  IF t1 = TotalX AND t2 = TotalY THEN GOTO exitmapsize
  DIM t$(4), B$(2)

  t$(1) = "Change Map Size from"
  t$(2) = STR$(TotalX) + " by" + STR$(TotalY)
  t$(3) = "TO " + STR$(t1) + " by" + STR$(t2)
  B$(1) = "PROCEED"
  B$(2) = "CANCEL "
   
  CALL Alert(t$(), B$(), 0, 0, c)

  IF c = 2 THEN GOTO exitmapsize
  DIM temp(t1 - 1, t2 - 1, 1 TO 3)
  FOR Y = 0 TO MIN(TotalY, t2) - 1
    FOR X = 0 TO MIN(TotalX, t1) - 1
      temp(X, Y, 1) = map(X, Y)
      temp(X, Y, 2) = road(X, Y)
      temp(X, Y, 3) = river(X, Y)
    NEXT X
  NEXT Y

  '** Resize map to new dimensions
  TotalX = t1: TotalY = t2
  MaxX = cellsizeX * TotalX - (px2 - px1)
  MaxY = cellsizeY * TotalY - (py2 - py1)
  Ysize = (py2 - py1) / cellsizeY + 1
  Xsize = (px2 - px1) / cellsizeX + 1

  REDIM map(TotalX - 1, TotalY - 1)
  REDIM road(TotalX - 1, TotalY - 1)
  REDIM river(TotalX - 1, TotalY - 1)

  FOR Y = 0 TO TotalY - 1
    FOR X = 0 TO TotalX - 1
      map(X, Y) = temp(X, Y, 1)
      IF map(X, Y) = 0 THEN map(X, Y) = 1 'default terrain for new areas
      road(X, Y) = temp(X, Y, 2)
      river(X, Y) = temp(X, Y, 3)
    NEXT X
  NEXT Y

  'The map dosn't have to be redrawn because its still the same map


exitmapsize:
  '** Clear input buffers
  DO: Future.UpdateMouse: LOOP UNTIL Future.MouseB = 0
  DO: LOOP UNTIL INKEY$ = ""

  Future.MouseOff
  Future.XMSput 0, 0, Workscreen
  Future.MouseOn

END SUB

SUB MenuGet (tmenu)
  FC& = BLACK
  FB& = LTBLUE
  FS& = WHITE

  SetViewPort 0, 0, 800, 600
  Future.MouseOff
  Future.XMSget 0, 0, 800, 600, Workscreen
  Future.MouseOn

  GOSUB drawSubMenu
  DO: Future.UpdateMouse: LOOP UNTIL Future.MouseB = 0

  DO
    Future.UpdateMouse
    tx = MIN(INT(Future.MouseX / 80) + 1, nSubm(0))
    ty = MIN(Future.MouseY / 16, nSubm(tx))
    IF tx <> tmenu OR ty <> cMenu THEN
      tmenu = tx
      cMenu = ty
      GOSUB drawSubMenu
    END IF
  LOOP UNTIL Future.MouseB AND 1

  mx = Future.MouseX
  my = Future.MouseY
  tx = MIN(INT(Future.MouseX / 80) + 1, nSubm(0))
  ty = MIN(Future.MouseY / 16, nSubm(tx))
  IF mx > 80 * nSubm(0) THEN
    tmenu = 0
  ELSEIF my - 16 > 16 * nSubm(tx) THEN
    tmenu = 0
  ELSE
    tmenu = tx * 10 + ty
  END IF

  Future.MouseOff
  Future.XMSput 0, 0, Workscreen
  Future.MouseOn
  DO: LOOP UNTIL INKEY$ = ""
  DO: Future.UpdateMouse: LOOP UNTIL Future.MouseB = 0


EXIT SUB
drawSubMenu:
  Future.MouseOff
  Page = Page XOR 1
  SetPage Page
  Future.XMSput 0, 0, Workscreen
  FOR m = 1 TO nSubm(0)
    IF m = tmenu THEN
      Future.PRINT 80 * (m - 1), 0, submenu(m, 0), WHITE, FB&
    ELSE
      Future.PRINT 80 * (m - 1), 0, submenu(m, 0), FC&, FB&
    END IF
  NEXT m
  FOR n = 1 TO nSubm(tmenu)
    IF n = cMenu THEN
      Future.PRINT 80 * (tmenu - 1), n * 16, submenu(tmenu, n), FC&, FS&
    ELSE
      Future.PRINT 80 * (tmenu - 1), n * 16, submenu(tmenu, n), FC&, FB&
    END IF
  NEXT n
  ViewPage Page
  Future.MouseOn
RETURN

END SUB

SUB MenuMake

  nSubm(0) = 6                     '***  Number of Menu Title
  submenu(0, 0) = SPACE$(12)       '***  Used for overwriting prev title
  
  submenu(1, 0) = "FILE"           '***  n,0 = Menu Title
  submenu(1, 1) = "Credits"        '***  n,m = menu item
  submenu(1, 2) = "Load      F6"
  submenu(1, 3) = "Save      F7"
  submenu(1, 4) = "Save AS   "
  submenu(1, 5) = "Save BMP"
  submenu(1, 6) = "Quit     esc"
  nSubm(1) = 6                     '*** Number of menu items under menu title

  submenu(2, 0) = "MODE"
  submenu(2, 1) = "Add Tile  "
  submenu(2, 2) = "Add Road1 "
  submenu(2, 3) = "Add Road2 "
  submenu(2, 4) = "Add River1"
  submenu(2, 5) = "Add River2"
  nSubm(2) = 5

  submenu(3, 0) = "View"
  submenu(3, 1) = "Dots are OFF"
  submenu(3, 2) = "HEXs are OFF"
  submenu(3, 3) = "Nums are OFF"
  IF CenterDots THEN submenu(3, 1) = "Dots are  ON"
  IF HEXs THEN submenu(3, 2) = "HEXs are  ON"
  IF HexNumbers THEN submenu(3, 3) = "Nums are  ON"
  nSubm(3) = 3
 
  submenu(4, 0) = "Map"
  submenu(4, 1) = "Map Info"
  submenu(4, 2) = "Resize Map"
  submenu(4, 3) = "Make Default"
  submenu(4, 4) = "Clear     F5"
  submenu(4, 5) = "Edit Colors "
  submenu(4, 6) = "Co-ord Sys  "
  nSubm(4) = 6

  submenu(5, 0) = "Hex "
  submenu(5, 1) = "INC aHEX"
  submenu(5, 2) = "DEC aHEX"
  submenu(5, 3) = "aHex = " + STR$(aHex)
  submenu(5, 4) = "Hex grain"
  nSubm(5) = 4
 
  submenu(6, 0) = "Tiles"
  submenu(6, 1) = "Select    "
  submenu(6, 2) = "Add New   "
  submenu(6, 3) = "Edit tile "
  submenu(6, 4) = "Tile Size"
  nSubm(6) = 4

END SUB

SUB ModeRiver (X, Y, col, row)
 
  CALL Map2Scrn(col, row, X, Y, X1, Y1)
  CALL CalcHexside(col, row, col2, row2, X, Y, DIR, DIR2)
  shft = 1: IF mode = 5 THEN shft = 256
  DIR = DIR * shft
  DIR2 = DIR2 * shft

  IF river(col, row) AND DIR THEN
    IF RMousebutton THEN
      river(col, row) = river(col, row) AND (NOT DIR)
      river(col2, row2) = river(col2, row2) AND (NOT DIR2)
    END IF
  ELSE
    IF LMousebutton THEN
      river(col, row) = river(col, row) OR DIR
      river(col2, row2) = river(col2, row2) OR DIR2
    END IF
  END IF


END SUB

SUB ModeRoad (X, Y, col, row)
 
  CALL Map2Scrn(col, row, X, Y, X1, Y1)
  CALL CalcHexside(col, row, col2, row2, X, Y, DIR, DIR2)
  shft = 1: IF mode = 3 THEN shft = 256
  DIR = DIR * shft
  DIR2 = DIR2 * shft

  IF road(col, row) AND DIR THEN
    IF RMousebutton THEN
      road(col, row) = road(col, row) AND (NOT DIR)
      road(col2, row2) = road(col2, row2) AND (NOT DIR2)
      MapDraw col, row, X, Y
    END IF
  ELSE
    IF LMousebutton THEN
      road(col, row) = road(col, row) OR DIR
      road(col2, row2) = road(col2, row2) OR DIR2
      MapDraw col, row, X, Y
    END IF
  END IF
  DO: Future.UpdateMouse: LOOP UNTIL Future.MouseB = 0

END SUB

SUB MouseUpdate (row, col, HY, HX)

  mouseposX = Future.MouseX
  mouseposY = Future.MouseY
  IF INBOX(mouseposX, mouseposY, px1, py1, px2, py2) THEN
    IF UPDOWN THEN
      col = INT((mouseposX + HX - px1) / cellsizeX)
      row = INT((mouseposY + HY - py1 + cellsizeY / 2 - (col MOD 2) * cellsizeY / 2) / cellsizeY)
    ELSE
      row = INT((mouseposY + HY - py1) / cellsizeY)
      col = INT((mouseposX + HX - px1 + cellsizeX / 2 - (row MOD 2) * cellsizeX / 2) / cellsizeX)
    END IF
    IF INBOX(col, row, 0, 0, TotalX - 1, TotalY - 1) THEN
    
      t$ = HexNumber$(col, row, MapNumK())
      Future.PRINT 0, 32, "HEX    :" + t$, RED, 0
      Future.PRINT 0, 48, "Terrain:" + STR$(map(col, row)), RED, 0
      Future.PRINT 0, 64, "ROAD   :" + BIN$(road(col, row)), RED, 0
      Future.PRINT 116, 64, BIN$(road(col, row) / 256), YELLOW, 0
      Future.PRINT 0, 80, "River  :" + BIN$(river(col, row)), RED, 0
      Future.PRINT 116, 80, BIN$(river(col, row) / 256), YELLOW, 0
    END IF
  END IF

END SUB

SUB PrgStart
  '** constants used for drawing roads
  ry(0) = 0: rx(0) = -1
  ry(1) = 1: rx(1) = -2
  ry(2) = 1: rx(2) = 2

  '**** Put Intial Page on Screen
  Future.CLS BLACK
  Future.PRINT 0, 580, "To Scroll use Arrow Keys, PgUp, PgDn, Home, End, Tab, Shft+tab. ESC=Quit", WHITE, 0
  FOR m = 1 TO nSubm(0)
     Future.PRINT 80 * (m - 1), 0, submenu(m, 0), BLACK, LTBLUE
  NEXT m
 
  Future.MouseOn
  CALL SetLocation(px1 + (px2 - px1) / 2, py1 + (py2 - py1) / 2)
  CALL MapDraw(-99, -99, 0, 0)

END SUB

SUB TileLoad (m$)
  Bytes = (cellsizeX - 0) * (cellsizeY - 0) + 10
  IF nTiles = 0 THEN nTiles = 2  '** just in case
  FOR i = 1 TO nTiles
    tileXMShand(i) = AllocateXMS(Bytes)
  NEXT i

  nColumns = 800 \ cellsizeX
  nRows = 600 \ cellsizeY
  maxTiles = MIN(nColumns * nRows, 200)
 
  Future.XMSget 0, 0, 799, 599, Workscreen

  IF EXIST%(m$ + ".bmp") THEN
    Future.LoadBMP m$ + ".bmp", 0, 0
    i = 0
    FOR k = 0 TO nRows - 1
      Y1 = cellsizeY * k: y2 = Y1 + cellsizeY - 1
      FOR j = 0 TO nColumns - 1
        i = i + 1
        X1 = cellsizeX * j
        x2 = X1 + cellsizeX - 1
        IF i <= nTiles THEN
          Future.XMSget X1, Y1, x2, y2, tileXMShand(i)
        END IF
      NEXT j
    NEXT k
  ELSE
    Future.CLS 0
    i = 0
    FOR k = 0 TO nRows - 1
      Y1 = cellsizeY * k: y2 = Y1 + cellsizeY - 1
      FOR j = 0 TO nColumns - 1
        i = i + 1
        X1 = cellsizeX * j
        x2 = X1 + cellsizeX - 1
        Future.FILLBOX X1, Y1, x2, y2, i
        IF i <= nTiles THEN
          Future.XMSget X1, Y1, x2, y2, tileXMShand(i)
        END IF
        Future.BOX X1, Y1, x2 + 1, y2 + 1, RED
      NEXT j
    NEXT k
    Future.SNAPSHOT m$ + ".bmp"
  END IF
 
  pal$ = m$ + ".pal"
  IF EXIST%(pal$) THEN
     LoadPal pal$
  ELSE
  END IF
 
  Future.XMSput 0, 0, Workscreen

END SUB

SUB TileSave (nt)
  SetViewPort 0, 0, 800, 600
  Future.MouseOff
  Future.XMSget 0, 0, 800, 600, Workscreen
  '** Draw tiles on backpage than save page
  Page = Page XOR 1
  SetPage Page
 
  nColumns = 800 \ cellsizeX
  nRows = 600 \ cellsizeY

  Future.CLS 0
  '**  draw boxes
  FOR k = 0 TO nRows - 1
    Y = cellsizeY * k
    Future.LINE 0, Y, 800, Y, RED, -1
  NEXT k
  FOR j = 0 TO nColumns - 1
    X = cellsizeX * j
    Future.LINE X, 0, X, 600, RED, -1
  NEXT j

  xTile = 0
  FOR k = 0 TO nRows - 1
    Y1 = cellsizeY * k: y2 = Y1 + cellsizeY - 1
    FOR j = 0 TO nColumns - 1
      xTile = xTile + 1
      X1 = cellsizeX * j: x2 = X1 + cellsizeX - 1
      IF xTile <= nt THEN Future.XMSput X1, Y1, tileXMShand(xTile)
    NEXT j
  NEXT k
  Future.SNAPSHOT mapname$ + ".bmp"
 
  '** replace front page
  Future.XMSput 0, 0, Workscreen
  ViewPage Page
  Future.MouseOn

END SUB

SUB TileSelect (c)
  SetViewPort 0, 0, 800, 600
  Future.MouseOff
  Future.XMSget 0, 0, 800, 600, Workscreen
   
  maxW = 790 \ (cellsizeX + 10)
  maxH = 575 \ (cellsizeY + 10)
  nRows = INT(SQR(nTiles))
  nColumns = INT(1! * nTiles / nRows + .99)
  w = nColumns * (cellsizeX + 10) + 10
  H = nRows * (cellsizeY + 10) + 25
  bx = (800 - w) \ 2
  by = (600 - H) \ 2

  '** Draw Tile selector box
  Future.FILLBOX bx, by, bx + w, by + H, WHITE
  Future.PRINT bx + (w - 11 * 8) \ 2, by + 2, "SELECT TILE", BLACK, RED
  k = 0
  FOR Y = 0 TO nRows - 1
    Y1 = (10 + cellsizeY) * Y + by + 25
    FOR X = 0 TO nColumns - 1
      X1 = (10 + cellsizeX) * X + bx + 10
      k = k + 1
      IF k <= nTiles THEN Future.XMSput X1, Y1, tileXMShand(k)
      IF k = c THEN
        Future.BOX X1 - 2, Y1 - 2, X1 + cellsizeX + 1, Y1 + cellsizeY + 1, RED
      END IF
    NEXT X
  NEXT Y
 
  '** wait for mouse button to be released
  DO: Future.UpdateMouse: LOOP UNTIL Future.MouseB = 0

  Future.MouseOn
  DO
    Future.UpdateMouse
    IF Future.MouseB THEN
      mx = Future.MouseX
      my = Future.MouseY
      IF INBOX(mx, my, bx + 10, by + 25, bx + w - 10, by + H - 10) THEN
        X = (mx - bx - 10) \ (cellsizeX + 10)
        Y = (my - by - 25) \ (cellsizeY + 10)
        c = Y * nColumns + X + 1
        IF c > nTiles THEN c = nTiles
        DONE = TRUE
        Future.MouseOff
        Future.XMSput 0, 0, Workscreen
        X1 = 800 - cellsizeX - 10
        Y1 = 20
        Future.XMSput X1, Y1, tileXMShand(c)
        Future.MouseOn
       
        IF Future.MouseB = 2 THEN
          '** Edit Tile
          '** First copy tile to temperory array
          DIM tempTile(cellsizeY * cellsizeX / 2 + 4)
          '** mouse shouldn't be anywhere near X1,Y1
          Future.GET X1, Y1, X1 + cellsizeX - 1, Y1 + cellsizeY - 1, tempTile()
          TileEdit tempTile()

          '** Transfer edited tile to XMS
          Future.MouseOff
          Future.PUT X1, Y1, tempTile()
          Future.XMSget X1, Y1, X1 + cellsizeX - 1, Y1 + cellsizeY - 1, tileXMShand(c)
          Future.MouseOn
          '**
        END IF
      END IF
    END IF
  LOOP UNTIL DONE
 
  DO: Future.UpdateMouse: LOOP UNTIL Future.MouseB = 0
  DO: LOOP UNTIL INKEY$ = ""
  
END SUB

