DECLARE SUB Map2Scrn (mapX%, mapY%, offX%, offY%, scrnX%, scrnY%)
DECLARE SUB MapDraw (Sx%, Sy%, X%, Y%)
DECLARE SUB GetPath (drive$, pp$)
DECLARE FUNCTION FormatInt$ (num%, length%)
DECLARE SUB EditString (s$, m$, keyc%, X%, Y%)
DECLARE SUB Alert (Text$(), Buttons$(), X%, Y%, ReturnButton%)
DECLARE FUNCTION HexNumber$ (mx%, my%, MK%())
DECLARE FUNCTION CalcDir% (R1%, C1%, R2%, C2%)
DECLARE FUNCTION ADJACENT% (col1%, row1%, col2%, row2%)
DECLARE SUB ShiftStatus (status%)
DECLARE SUB ColorPalLoad (PD%())
DECLARE FUNCTION INBOX% (X%, Y%, X1%, Y1%, x2%, y2%)
DECLARE FUNCTION MIN% (V1%, V2%)
DECLARE FUNCTION INBOX% (X%, Y%, X1%, Y1%, x2%, y2%)
DECLARE FUNCTION MAX% (V1%, V2%)
REM $INCLUDE: 'future.bi'
REM $DYNAMIC
 
  COMMON SHARED Workscreen, Page
  COMMON SHARED mouseposY, mouseposX, LMousebutton, RMousebutton
  COMMON SHARED HexNumbers, CenterDots, HEXs, aHex
  COMMON SHARED TotalX, TotalY, cellsizeX, cellsizeY
  COMMON SHARED MaxX, MaxY, Ysize, Xsize, UPDOWN
  COMMON SHARED Mode, maxTiles, mapname$, nTiles, tileXMShand()

  '********************* KeyBoard Constants ****************
  CONST LEFT = 1075, RIGHT = 1077, PGDN = 1081, PGUP = 1073
  CONST UP = 1072, DOWN = 1080, ESC = 27, TABKEY = 9, CR = 13
  CONST HOME = 1071, ENDKEY = 1079, INSERT = 1082, DELETE = 1083
  CONST BACKSPACE = 8, SHFTTAB = 1015
  '****************  Color Constants ************************
  CONST BLACK = 0, WHITE = 4, RED = 3, DGREEN = 2, GREEN = 5, LTGREEN = 1
  CONST DBLUE = 6, BLUE = 7, LTBLUE = 8, LtGray = 9, GRAY = 10, DrGray = 11
  CONST YELLOW = 12, LTBROWN = 13, BROWN = 14
  '************************ Logical Constants *******************
  CONST TRUE = -1, FALSE = 0
  '********************** Map Constants **************************
  '** Viewport size in pixels
  CONST px1 = 10, py1 = 100, px2 = 780, py2 = 540
  '** scroll constants in pixels
  CONST bigstep = py2 - py1 - 10, smallstep = 40

  CONST SLIDERW = 6     '** Slider thickness
  CONST THICKNESS = 2   '** For roads and rivers

REM $STATIC
FUNCTION ADJACENT (col1, row1, col2, row2)
  'not used in HExmap 4.5

  ADJACENT = FALSE
  IF UPDOWN THEN
    IF col1 - col2 = 0 THEN
      IF ABS(row1 - row2) = 1 THEN ADJACENT = TRUE
    ELSEIF ABS(col1 - col2) = 1 THEN
      test = row1 - row2 + col1 MOD 2
      IF test = 0 OR test = 1 THEN ADJACENT = TRUE
    END IF
  ELSE
    IF row1 - row2 = 0 THEN
      IF ABS(col1 - col2) = 1 THEN ADJACENT = TRUE
    ELSEIF ABS(row1 - row2) = 1 THEN
      test = col1 - col2 + row1 MOD 2
      IF test = 0 OR test = 1 THEN ADJACENT = TRUE
    END IF
  END IF

END FUNCTION

FUNCTION CalcDir (R1, C1, R2, C2)

  '** not used in Hexmap 4.5
  IF UPDOWN THEN
    IF C1 = C2 THEN
      IF R2 > R1 THEN
        CalcDir = 8
      ELSE
        CalcDir = 1
      END IF
    ELSEIF C2 > C1 THEN
      IF R2 - R1 - (C1 MOD 2) THEN
        CalcDir = 2
      ELSE
        CalcDir = 4
      END IF
    ELSE
      IF R2 - R1 - (C1 MOD 2) THEN
        CalcDir = 32
      ELSE
        CalcDir = 16
      END IF
    END IF
  ELSE
    IF R1 = R2 THEN
      IF C2 > C1 THEN
        CalcDir = 1
      ELSE
        CalcDir = 8
      END IF
    ELSEIF R2 > R1 THEN
      IF C2 - C1 - (R1 MOD 2) THEN
        CalcDir = 16
      ELSE
        CalcDir = 32
      END IF
    ELSE
      IF C2 - C1 - (R1 MOD 2) THEN
        CalcDir = 4
      ELSE
        CalcDir = 2
      END IF
    END IF
  END IF
END FUNCTION

SUB CalcHexside (col, row, col2, row2, offX, offY, DIR, DIR2)

  CALL Map2Scrn(col, row, offX, offY, X1, Y1)
  IF UPDOWN THEN

    Ypos = mouseposY - Y1
    Xpos = mouseposX - X1
    North = row - 1 + col MOD 2
    South = row + col MOD 2
   
    IF Ypos < 6 THEN
      DIR = 1: DIR2 = 8: col2 = col: row2 = row - 1
    ELSEIF Ypos > cellsizeY - 6 THEN
      DIR = 8: DIR2 = 1: col2 = col: row2 = row + 1
    ELSEIF Xpos < 6 THEN
      IF Ypos < cellsizeY \ 2 - 4 THEN
        '** NW
        DIR = 32: DIR2 = 4: col2 = col - 1: row2 = North
      ELSEIF Ypos > cellsizeY \ 2 + 4 THEN
        '** SW
        DIR = 16: DIR2 = 2: col2 = col - 1: row2 = South
      END IF
    ELSEIF Xpos > cellsizeX - 6 THEN
      IF Ypos < cellsizeY \ 2 - 4 THEN
        '** NE
        DIR = 2: DIR2 = 16: col2 = col + 1: row2 = North
      ELSEIF Ypos > cellsizeY \ 2 + 4 THEN
        '** SE
        DIR = 4: DIR2 = 32: col2 = col + 1: row2 = South
      END IF
    END IF

  ELSE
    West = col - 1 + row MOD 2
    East = col + row MOD 2
    col2 = col: row2 = row
    IF mouseposY - Y1 < 4 THEN
      row2 = row - 1
      IF mouseposX - X1 < cellsizeX / 2 THEN
        '** NW side
        DIR = 4: DIR2 = 32: col2 = West
      ELSE
        '** NE side
        DIR = 2: DIR2 = 16: col2 = East
      END IF
    ELSEIF mouseposY - Y1 > cellsizeY - 4 THEN
      row2 = row + 1
      IF mouseposX - X1 < cellsizeX / 2 THEN
        '** SW side
        DIR = 16: DIR2 = 2: col2 = West
      ELSE
        '** SE side
        DIR = 32: DIR2 = 4: col2 = East
      END IF
    ELSEIF mouseposX - X1 < 4 THEN
      '** West side
      DIR = 8: DIR2 = 1: col2 = col - 1
    ELSEIF mouseposX - X1 > cellsizeX - 4 THEN
      '** East side
      DIR = 1: DIR2 = 8: col2 = col + 1
    END IF
  END IF

END SUB

SUB ColorGetPoint (PalNum%)
  DIM B(8)
  Future.GET 1, 1, 2, 2, B()
  PalNum = B(2) AND 255
END SUB

SUB ColorPalLoad (PD())

  SavePal "tempPAL.txt"

  OPEN "tempPAL.txt" FOR INPUT AS #1
  FOR I = 0 TO 255
    LINE INPUT #1, t$
    PD(I, 0) = VAL(LEFT$(t$, 3))
    PD(I, 1) = VAL(MID$(LTRIM$(t$), 4, 3))
    PD(I, 2) = VAL(RIGHT$(t$, 3))
  NEXT I
  CLOSE #1

END SUB

SUB Credits
  DIM t$(9), B$(1)

  t$(1) = "       Hex Map Maker  "
  t$(2) = "   Version 4.5  11/13/2000 "
  t$(3) = "Created by Thomas A Stevenson "
  t$(4) = "  thomas99@phenixcable.net"
  t$(5) = ""
  t$(6) = "  Using Future.Library 3.5"
  t$(7) = "   By Michael Rye Soreason "
  t$(8) = "     and Jorden Chamid     "

  B$(1) = "  OK  "


  CALL Alert(t$(), B$(), 0, 0, c)


END SUB

FUNCTION HexNumber$ (mx, my, MK())

  'MapNumK(1)   Prime offset
  'MapNumK(2)   row multipler
  'MapNumK(3)   even row/column offset
  'MapNumK(4)   odd row/column offset
  'MapNumK(5)   Column multiplier

  IF UPDOWN THEN
    n = MK(5) * mx + MK(1)
    IF (mx MOD 2) = 1 THEN
      n = n + MK(2) * my + MK(4)
    ELSE
      n = n + MK(2) * my + MK(3)
    END IF
  ELSE
    n = MK(2) * my + MK(1)
    IF (my MOD 2) = 1 THEN
      n = n + MK(5) * mx + MK(4)
    ELSE
      n = n + MK(5) * mx + MK(3)
    END IF
  END IF

  s$ = "0000"
  t$ = s$ + LTRIM$(STR$(n))
  HexNumber$ = MID$(t$, LEN(t$) - 3, 4)

END FUNCTION

SUB HexSides (hx1, hy1, side, rx1, ry1, rx2, ry2)

  IF UPDOWN THEN GOTO updownlabel

  hy2 = hy1 + cellsizeY
  hx12 = hx1 + cellsizeX / 2
  hx2 = hx1 + cellsizeX
  SELECT CASE side
  CASE 1
    rx1 = hx2
    rx2 = hx2
    ry1 = hy1 + aHex
    ry2 = hy2 - aHex
  CASE 2
    rx1 = hx12
    rx2 = hx2
    ry1 = hy1 - aHex
    ry2 = hy1 + aHex
  CASE 3
    rx1 = hx1
    rx2 = hx12
    ry1 = hy1 + aHex
    ry2 = hy1 - aHex
  END SELECT
EXIT SUB

updownlabel:
  hx2 = hx1 + cellsizeX
  SELECT CASE side
  CASE 1
    rx1 = hx1 + aHex
    rx2 = hx2 - aHex
    ry1 = hy1
    ry2 = hy1
  CASE 2
    rx1 = hx2 - aHex
    rx2 = hx2 + aHex
    ry1 = hy1
    ry2 = hy1 + cellsizeY / 2
  CASE 3
    rx1 = hx2 + aHex
    rx2 = hx2 - aHex
    ry1 = hy1 + cellsizeY / 2
    ry2 = hy1 + cellsizeY
  END SELECT

  EXIT SUB
END SUB

SUB Map2Scrn (mapX, mapY, offX, offY, scrnX, scrnY)

  IF UPDOWN THEN
    scrnX = mapX * cellsizeX + px1 - offX
    scrnY = mapY * cellsizeY - offY + py1 - ((mapX + 1) MOD 2) * cellsizeY / 2
  ELSE
    scrnY = mapY * cellsizeY - offY + py1
    scrnX = mapX * cellsizeX + px1 - offX - ((mapY + 1) MOD 2) * cellsizeX / 2
  END IF

END SUB

SUB MapCellSize
  SetViewPort 0, 0, 800, 600
  Future.MouseOff
  Future.XMSget 0, 0, 800, 600, Workscreen

  bx = 300: by = 200: w = 300: H = 100
  Future.FILLBOX bx, by, bx + w, by + H, BLACK
  Future.FILLBOX bx + 2, by + 2, bx + w - 2, by + H - 2, RED
  Future.PRINT bx + 20, by + 1 * 16, "Input Cell Size in pixels", WHITE, RED
  Future.PRINT bx + 40, by + 3 * 16, "X pixels:", WHITE, RED
  Future.PRINT bx + 40, by + 4 * 16, "Y pixels", WHITE, RED
  t2$ = FormatInt$(cellsizeY, 3)
  Future.PRINT bx + 120, by + 4 * 16, t2$, WHITE, RED

  '***  Get New CELL Size
  t1$ = FormatInt$(cellsizeX, 3)
  CALL EditString(t1$, "0123456789", k, bx + 120, by + 3 * 16)
  Future.PRINT bx + 120, by + 3 * 16, t1$, WHITE, RED
  k = 0
  CALL EditString(t2$, "0123456789", k, bx + 120, by + 4 * 16)

  t1 = VAL(t1$)
  t2 = VAL(t2$)
  CX = MAX(MIN(t1, 200), 10)
  CY = MAX(MIN(t2, 200), 10)
  Future.MouseOff

 
  Bytes = CX * CY + 10
  IF CX * CY > cellsizeX * cellsizeY THEN resize = TRUE
  FOR I = 1 TO nTiles
    Future.XMSput 100, 100, tileXMShand(I)
    IF resize THEN
      DeallocateXMS tileXMShand(I)
      tileXMShand(I) = AllocateXMS(Bytes)
    END IF
    Future.XMSget 100, 100, 99 + CX, 99 + CY, tileXMShand(I)
  NEXT I


  cellsizeX = CX
  cellsizeY = CY
  MaxX = cellsizeX * TotalX - (px2 - px1)
  MaxY = cellsizeY * TotalY - (py2 - py1)
  Ysize = (py2 - py1) \ cellsizeY + 1
  Xsize = (px2 - px1) \ cellsizeX + 1

  Future.XMSput 0, 0, Workscreen
  Future.MouseOn

END SUB

SUB MapDefault (mapname$)
  DIM t$(3), B$(2)

  t$(1) = "Set " + mapname$
  t$(2) = "To load when Hexmap initializes?"
  t$(3) = ""
  B$(1) = "  YES  "
  B$(2) = " CANCEL"

  CALL Alert(t$(), B$(), 0, 0, c)
    
  IF c = 1 THEN
    f = FREEFILE
    OPEN "default.map" FOR OUTPUT AS #f
    PRINT #1, mapname$
    CLOSE f
  END IF

END SUB

SUB MapGrain
    DIM t$(5), B$(2)

    CALL GetPath("C", pp$)
    t$(1) = "Select map Grain"
    t$(2) = "Hexes can either be in line"
    t$(3) = "from left to right"
    t$(4) = "or from Top to bottom"

    B$(1) = "ACROSS "
    B$(2) = "UP-DOWN"

    CALL Alert(t$(), B$(), 0, 0, c)
    IF c = 1 THEN
      UPDOWN = FALSE
    ELSE
      UPDOWN = TRUE
    END IF
    CALL MapDraw(-99, -99, HX, HY)

END SUB

SUB MapNamed (m$)
  SetViewPort 0, 0, 800, 600
  Future.MouseOff
  Future.XMSget 0, 0, 800, 600, Workscreen

  bx = 300: by = 200: w = 300: H = 100
  Future.FILLBOX bx, by, bx + w, by + H, BLACK
  Future.FILLBOX bx + 2, by + 2, bx + w - 2, by + H - 2, RED
  Future.PRINT bx + 20, by + 1 * 16, "Input Map Name ", WHITE, RED
  Future.PRINT bx + 20, by + 2 * 16, "Excluding Path and extension ", WHITE, RED

  '***  Get New Map Size
  mask$ = "QWERTYUIOPASDFGHJKLZXCVBNMqwertyuiopasdfghjklzxcvbnm012345689"
  m$ = LEFT$(m$ + SPACE$(8), 8)  'set max length to 8
  CALL EditString(m$, mask$, k, bx + 40, by + 3 * 16)


  '** Clear input buffers
  DO: Future.UpdateMouse: LOOP UNTIL Future.MouseB = 0
  DO: LOOP UNTIL INKEY$ = ""

  Future.MouseOff
  Future.XMSput 0, 0, Workscreen
  Future.MouseOn

END SUB

SUB MapNumbering (MapNumK%())
  SetViewPort 0, 0, 800, 600
  Future.MouseOff
  Future.XMSget 0, 0, 800, 600, Workscreen

  bx = 300: by = 200: w = 300: H = 170
  Future.FILLBOX bx, by, bx + w, by + H, BLACK
  Future.FILLBOX bx + 2, by + 2, bx + w - 2, by + H - 2, RED

  Future.PRINT bx + 20, by + 8, "Edit Parameters For", WHITE, RED
  Future.PRINT bx + 20, by + 24, "Calculating Map Coordinates", WHITE, RED
  by = by + 40: bx = bx + 30

  '** MapNumK(1)   Prime offset
  '** MapNumK(2)   row multipler
  '** MapNumK(3)   even row/column offset
  '** MapNumK(4)   odd row/column offset
  '** MapNumK(5)   Column multiplier
  Future.PRINT bx, by + 1 * 16, "Prime Offset:", WHITE, RED
  Future.PRINT bx, by + 2 * 16, "Row Multi +/-1:", WHITE, RED
  Future.PRINT bx, by + 3 * 16, "Even Row/Col Offset", WHITE, RED
  Future.PRINT bx, by + 4 * 16, "Odd Row/Col Offset", WHITE, RED
  Future.PRINT bx, by + 5 * 16, "Column Multi +/-1:", WHITE, RED

  Future.PRINT bx, by + 110, "Press DONE or Cancel", WHITE, BLACK
  Future.PRINT bx + 6 * 8, by + 110, "D", RED, BLACK
  Future.PRINT bx + 14 * 8, by + 110, "C", RED, BLACK
  t$ = HexNumber$(TotalX - 1, TotalY - 1, MapNumK())
  bx = bx + 150
  Future.PRINT bx + 30, by + 110, HexNumber$(0, 0, MapNumK()), WHITE, BLACK
  Future.PRINT bx + 70, by + 110, t$, WHITE, BLACK

  DIM undo(5)
  FOR Y = 1 TO 5
    undo(Y) = MapNumK(Y)
    Future.PRINT bx, by + Y * 16, FormatInt$(MapNumK(Y), 4), WHITE, RED
  NEXT Y
  old = 1: focus = 1
  Future.PRINT bx, by + focus * 16, FormatInt$(MapNumK(focus), 4), WHITE, BLACK


  DO
    ky$ = INKEY$
    SELECT CASE LEN(ky$)
    CASE 0: keyc = 0
    CASE 1: keyc = ASC(ky$)
    CASE ELSE: keyc = 1000 + ASC(RIGHT$(ky$, 1))
    END SELECT
   
    SELECT CASE keyc
    CASE 0
    CASE ASC("c"), ASC("C")
      DONE = TRUE
      FOR Y = 1 TO 5
        MapNumK(Y) = undo(Y)
      NEXT Y
    CASE ASC("d"), ASC("D")
      DONE = TRUE
    CASE HOME: focus = 1
    CASE ENDKEY: focus = 5
    CASE UP: focus = focus - 1
    CASE DOWN: focus = focus + 1
    CASE 8, 27, 45, 48 - 57
      '** backspace,-,0-9
      s$ = FormatInt$(MapNumK(focus), 4)
      Future.PRINT bx, by + focus * 16, SPACE$(4), RED, WHITE
      CALL EditString(s$, "-0123456789", keyc, bx, by + focus * 16)
      MapNumK(focus) = VAL(s$)
      Future.PRINT bx, by + focus * 16, FormatInt$(MapNumK(focus), 4), WHITE, BLACK
      IF keyc = UP THEN focus = focus - 1
      IF keyc = DOWN THEN focus = focus + 1
    CASE ELSE
      BEEP
    END SELECT

    IF focus > 5 THEN focus = 1
    IF focus < 1 THEN focus = 5
    IF focus <> old THEN
      Future.PRINT bx, by + old * 16, FormatInt$(MapNumK(old), 4), WHITE, RED
      Future.PRINT bx, by + focus * 16, FormatInt$(MapNumK(focus), 4), WHITE, BLACK
      old = focus
      t$ = HexNumber$(TotalX - 1, TotalY - 1, MapNumK())
      Future.PRINT bx + 30, by + 110, HexNumber$(0, 0, MapNumK()), WHITE, BLACK
      Future.PRINT bx + 70, by + 110, t$, WHITE, BLACK
    END IF

  LOOP UNTIL DONE

  '** Clear input buffers
  DO: Future.UpdateMouse: LOOP UNTIL Future.MouseB = 0
  DO: LOOP UNTIL INKEY$ = ""

  Future.MouseOff
  Future.XMSput 0, 0, Workscreen
  Future.MouseOn

END SUB

SUB RoadDir (rx1, ry1, rx2, ry2, side)

  IF UPDOWN THEN
    SELECT CASE side
    CASE 1
      rx2 = rx1
      ry2 = ry1 - cellsizeY
    CASE 2
      rx2 = rx1 + cellsizeX
      ry2 = ry1 - cellsizeY \ 2
    CASE 3
      rx2 = rx1 + cellsizeX
      ry2 = ry1 + cellsizeY \ 2
    END SELECT
  ELSE
    SELECT CASE side
    CASE 1
      rx2 = rx1 + cellsizeX
      ry2 = ry1
    CASE 2
      rx2 = rx1 + cellsizeX \ 2
      ry2 = ry1 - cellsizeY
    CASE 3
      rx2 = rx1 - cellsizeX \ 2
      ry2 = ry1 - cellsizeY
    END SELECT
  END IF

END SUB

SUB setcolors


  ChangePal BLACK, 0, 0, 0
  ChangePal WHITE, 63, 63, 63
  ChangePal RED, 63, 0, 0
  ChangePal DBLUE, 0, 40, 63
  ChangePal BLUE, 0, 0, 63
  ChangePal LTBLUE, 0, 10, 43
  ChangePal DGREEN, 0, 45, 0
  ChangePal GREEN, 0, 53, 0
  ChangePal LTGREEN, 0, 63, 0
  ChangePal DrGray, 22, 22, 22
  ChangePal GRAY, 40, 40, 40
  ChangePal LtGray, 50, 50, 50
  ChangePal YELLOW, 63, 63, 0
  ChangePal LTBROWN, 43, 23, 0
  ChangePal BROWN, 30, 15, 0

  '** default colors
  ChangePal (CenterDotCOLOR), 63, 63, 63
  ChangePal (HexCOLOR), 63, 63, 63
  ChangePal (NumberCOLOR), 63, 0, 0
  ChangePal (Rd1COLOR), 0, 0, 0
  ChangePal (Rd2COLOR), 43, 23, 0
  ChangePal (Rv1COLOR), 0, 0, 63
  ChangePal (Rv2COLOR), 63, 63, 0

END SUB

SUB TileEdit (orginalData())
  SetViewPort 0, 0, 800, 600
  Future.MouseOff
  Tempscreen = AllocateXMS(480000)
  Future.XMSget 0, 0, 800, 600, Tempscreen

  DIM c&(2), B(8)
  DIM undo(UBOUND(orginalData))
  c&(0) = RED
  c&(1) = GREEN
  c&(2) = BLUE
  P$ = SPACE$(4)
  DIM PalData(255, 2)
  CALL ColorPalLoad(PalData())

  CX = 10: by = 360: w = 136
  PColor = orginalData(3) AND 255

  Future.CLS 0
  Future.FILLBOX CX, by, CX + w, by + w, PColor
  Future.BOX CX - 1, by - 1, CX + w + 1, by + w + 1, WHITE
  Future.PRINT CX, by - 20, "Pal Entry: " + STR$(PColor) + "  ", RED, BLACK
  bx = CX + w + 20

  '** Draw Pallete editor
  FOR I = 0 TO 2
    Future.PRINT bx + I * 40, by, "  63 ", WHITE, c&(I)
    Future.PRINT bx + I * 40, by + 20, " +10 ", WHITE, c&(I)
    Future.PRINT bx + I * 40, by + 40, "  +1 ", WHITE, c&(I)
    t$ = RIGHT$(P$ + STR$(PalData(PColor, I)), 5)
    Future.PRINT bx - 10 + I * 40, by + 60, t$, WHITE, BLACK
    Future.PRINT bx + I * 40, by + 80, "  -1 ", WHITE, c&(I)
    Future.PRINT bx + I * 40, by + 100, " -10 ", WHITE, c&(I)
    Future.PRINT bx + I * 40, by + 120, "   0 ", WHITE, c&(I)
  NEXT I
  Future.BOX bx - 1, by - 1, bx + 121, by + w + 1, WHITE
                                             
  '** Draw Pallete table
  FOR Y = 0 TO 3
    Y1 = 512 + Y * 20
    FOR X = 0 TO 63
      Future.FILLBOX 8 + X * 12, Y1, 8 + X * 12 + 12, Y1 + 20, Y * 64 + X
    NEXT X
  NEXT Y
  Future.BOX 7, 511, 777, 595, WHITE

  '** Orgins: sprite X, sprite Y, Zoom X, Zoom Y
  '** Sprite: width, height
  Sx = 20: Sy = 40: lx = bx + 127: ly = Sy
  sw = orginalData(0): sh = orginalData(1)   '** inclusive !!
  Future.PUT Sx, Sy, orginalData()
  Future.GET Sx, Sy, Sx + sw, Sy + sh, undo()

  '** Action Bar
  DIM Action(9) AS STRING * 10
  Action(0) = "   EXIT   "
  Action(1) = "  RESTORE "
  Action(2) = "   UNDO"
  Action(3) = "FLIP UP/Dn"
  Action(4) = "    PEN   "
  Action(5) = " FLIP L/R "
  Action(6) = "   BOX "
  Action(7) = "  LINE"
  Action(8) = "  CLEAR"
  Action(9) = " FILL BOX"
  FOR I = 0 TO 9
    Future.PRINT I * 80, 0, Action$(I), WHITE, BLUE
  NEXT I
  GOSUB DrawZoom
  undobuffer = AllocateXMS((1# * (sh + 1#) * (sw + 1#) * lww) * lww + 2)
  Future.XMSget lx, ly, lx2, ly2, undobuffer

  Future.MouseOn
  DO
    Future.UpdateMouse
    mx = Future.MouseX
    my = Future.MouseY
    GOSUB Display
    IF Future.MouseB AND 1 THEN
      IF INBOX(mx, my, lx, ly, lx2, ly2) THEN GOSUB changePixel
      IF INBOX(mx, my, bx, by, bx + 120, by + 136) THEN GOSUB Adjcolor
      IF INBOX(mx, my, 8, 512, 776, 592) THEN GOSUB NewColor
      DO: Future.UpdateMouse: LOOP UNTIL Future.MouseB = 0
    ELSEIF Future.MouseB AND 2 THEN
      ShiftStatus KeyState
      IF KeyState AND 4 THEN
        IF INBOX(mx, my, lx, ly, lx2, ly2) THEN GOSUB GrabColor
      ELSE
        GOSUB undo
      END IF
    END IF
  LOOP
                                                           
EXIT SUB

TakeAction:
  Future.MouseOff
  SELECT CASE m
  CASE 0    '  EXIT
    '** Save changes
    Future.GET Sx, Sy, Sx + sw, Sy + sh, orginalData()

    'restore back page
    Page = Page XOR 1
    SetPage Page
    Future.XMSput 0, 0, Tempscreen
    ViewPage Page
    '** restore front page
    Page = Page XOR 1
    SetPage Page
    Future.XMSput 0, 0, Tempscreen
    ViewPage Page
    DeallocateXMS Tempscreen 'free up XMS memory
    DeallocateXMS undobuffer 'free up XMS memory
    Future.MouseOn
    EXIT SUB
  CASE 1    '  RESTORE
    Future.GET Sx, Sy, Sx + sw, Sy + sh, undo()
    Future.XMSget lx, ly, lx2, ly2, undobuffer
    Future.PUT Sx, Sy, orginalData()
    GOSUB DrawZoom
  CASE 2    '  UNDO
    Future.PUT Sx, Sy, undo()
    Future.XMSput lx, ly, undobuffer
  CASE 3    '  FLIP UP/Dn
    REDIM s1(sw + 2), s2(sw + 2)
    Future.GET Sx, Sy, Sx + sw, Sy + sh, undo()
    Future.XMSget lx, ly, lx2, ly2, undobuffer
    FOR Y = 0 TO sh \ 2
      Future.GET Sx, Sy + Y, Sx + sw, Sy + Y, s1()
      Future.GET Sx, Sy + sh - Y, Sx + sw, Sy + sh - Y, s2()
      Future.PUT Sx, Sy + sh - Y, s1()
      Future.PUT Sx, Sy + Y, s2()
    NEXT Y
    GOSUB DrawZoom
  CASE 4    ' Pen
    Tool = 0
    Tool$ = "   PEN  "
  CASE 5    '  FLIP L/R
    REDIM s1(sw + 2), s2(sw + 2)
    Future.GET Sx, Sy, Sx + sw, Sy + sh, undo()
    Future.XMSget lx, ly, lx2, ly2, undobuffer
    FOR X = 0 TO sw \ 2
      Future.GET Sx + X, Sy, Sx + X, Sy + sh, s1()
      Future.GET Sx + sw - X, Sy, Sx + sw - X, Sy + sh, s2()
      Future.PUT Sx + sw - X, Sy, s1()
      Future.PUT Sx + X, Sy, s2()
    NEXT X
    GOSUB DrawZoom
  CASE 6    '  BOX
    Tool = 1
    Tool$ = "   BOX  "
  CASE 7    '  LINE
    Tool = 2
    Tool$ = "  LINE  "
  CASE 8    '  CLEAR
    Future.FILLBOX Sx, Sy, Sx + sw, Sy + sh, PColor
    GOSUB DrawZoom
  CASE 9    '  FILL BOX
    Tool = 3
    Tool$ = "FILL BOX"
  END SELECT
  Future.PRINT lx + 100, 20, Tool$, WHITE, RED
  Future.MouseOn
RETURN

Display:
  Display$ = "X=    Y=   "
  IF INBOX(mx, my, lx, ly, lx2, ly2) THEN
    xS = (mx - lx) \ lww
    yS = (my - ly) \ lww
    MID$(Display$, 3) = STR$(xS)
    MID$(Display$, 9) = STR$(yS)
  ELSEIF INBOX(mx, my, 0, 0, 800, 16) THEN
    m = MIN(mx \ 80, 9)
    Future.MouseOff
    Future.PRINT m * 80, 0, Action$(m), WHITE, RED
    Future.MouseOn
    DO
      Future.UpdateMouse
      mx = MIN(Future.MouseX \ 80, 9)
      my = Future.MouseY
      IF Future.MouseB AND 1 THEN
        Future.MouseOff
        Future.PRINT m * 80, 0, Action$(m), WHITE, BLUE
        Future.MouseOn
        DO: Future.UpdateMouse: LOOP UNTIL Future.MouseB = 0
        GOSUB TakeAction
      END IF
    LOOP UNTIL mx <> m OR my > 16
    Future.MouseOff
    Future.PRINT m * 80, 0, Action$(m), WHITE, BLUE
    Future.MouseOn

  ELSE
    xS = -1: yS = -1
  END IF
  IF xS = oldx AND yS = oldy THEN
    '** do nothing
  ELSE
    Future.PRINT lx, ly - 20, Display$, RED, WHITE
    oldx = xS: oldy = yS
  END IF
RETURN

changePixel:
  xS = (mx - lx) \ lww
  yS = (my - ly) \ lww
  Y1 = ly + lww * yS + gridV
  X1 = lx + lww * xS + gridV
  w2 = lww - 2 * gridV
  IF Tool THEN
    GOSUB Getx2y2
  ELSE
    Future.MouseOff
    Future.GET Sx, Sy, Sx + sw, Sy + sh, undo()
    Future.XMSget lx, ly, lx2, ly2, undobuffer
    Future.PSET Sx + xS, Sy + yS, PColor
    Future.FILLBOX X1, Y1, X1 + w2, Y1 + w2, PColor
    Future.MouseOn
  END IF
RETURN

NewColor:
  PColor = 64 * ((my - 512) \ 20) + (mx - 8) \ 12
Colorgrabed:
  Future.FILLBOX CX, by, CX + w, by + w, PColor
  Future.PRINT CX, by - 20, "Pal Entry: " + STR$(PColor) + "   ", RED, BLACK
  Future.PRINT bx + 4, by + 60, STR$(PalData(PColor, 0)) + "  ", WHITE, BLACK
  FOR I = 1 TO 2
    t$ = RIGHT$(P$ + STR$(PalData(PColor, I)), 5)
    Future.PRINT bx - 10 + I * 40, by + 60, t$, WHITE, BLACK
  NEXT I
RETURN

Adjcolor:
  k = (mx - bx) \ 40
  a = (my - by) \ 20
  SELECT CASE a
  CASE 0
    PalData(PColor, k) = 63
  CASE 1
    PalData(PColor, k) = MIN(PalData(PColor, k) + 10, 63)
  CASE 2
    PalData(PColor, k) = MIN(PalData(PColor, k) + 1, 63)
  CASE 3
    BEEP
  CASE 4
    PalData(PColor, k) = MAX(PalData(PColor, k) - 1, 0)
  CASE 5
    PalData(PColor, k) = MAX(PalData(PColor, k) - 10, 0)
  CASE 6
    PalData(PColor, k) = 0
  END SELECT
  t$ = RIGHT$(P$ + STR$(PalData(PColor, k)), 5)
  Future.PRINT bx - 10 + k * 40, by + 60, t$, WHITE, BLACK
  ChangePal PColor, PalData(PColor, 0), PalData(PColor, 1), PalData(PColor, 2)
RETURN

DrawZoom:
  Future.XMSget 0, 0, 800, 600, Workscreen
  Page = Page XOR 1
  SetPage Page
  Future.XMSput 0, 0, Workscreen

  '** Zoom box width & height of zoomed pixel
  MaxLw = 790 - lx
  MaxLh = 500 - ly
  lww = MIN(MaxLw \ sw, MaxLh \ sh)
  lx2 = lx + (sw + 1) * lww    '** Right zoom edge X
  ly2 = ly + (sh + 1) * lww  '** Bottom zoom Y

  '** Draw Zoomed sprite
  FOR Y = 0 TO sh
    Y1 = ly + lww * Y
    FOR X = 0 TO sw
      Future.GET Sx + X, Sy + Y, Sx + X + 2, Sy + Y + 2, B()
      PColor = B(2) AND 255
      X1 = lx + X * lww
      Future.FILLBOX X1, Y1, X1 + lww, Y1 + lww, PColor
    NEXT X
  NEXT Y

  '** Draw gridlines
  IF lww > 3 THEN
    gridV = 1
    FOR Y = 0 TO sh + 1
      Y1 = ly + lww * Y
      Future.LINE lx, Y1, lx2, Y1, WHITE, -1
    NEXT Y
    FOR X = 0 TO sw + 1
      X1 = lx + X * lww
      Future.LINE X1, ly, X1, ly2, WHITE, -1
    NEXT X
  END IF
  ViewPage Page
RETURN
  
Getx2y2:
  sbuffer = AllocateXMS((1# * (sh + 1#) * (sw + 1#) * lww) * lww + 2)
  Future.MouseOff
  Future.GET Sx, Sy, Sx + sw, Sy + sh, undo()
  Future.XMSget lx, ly, lx2, ly2, undobuffer
  '** Make sure front and back pages match
  Future.XMSget 0, 0, 800, 600, Workscreen
  Page = Page XOR 1: SetPage Page
  Future.XMSput 0, 0, Workscreen
  Page = Page XOR 1: SetPage Page

  SetMouseRange lx, ly, lx2, ly2
  Future.XMSget lx, ly, lx2, ly2, sbuffer
  SetViewPort lx, ly, lx2, ly2
  Future.MouseOn

  DO
    Future.UpdateMouse
    mx = Future.MouseX
    my = Future.MouseY
    xP = (mx - lx) \ lww
    yP = (my - ly) \ lww
    x2 = lx + lww * xP - gridV
    y2 = ly + lww * yP - gridV
    IF x2 <> z1 OR y2 <> z2 THEN
      GOSUB DrawShape
      z1 = x2: z2 = y2
    END IF
  LOOP WHILE Future.MouseB AND 1

  SetMouseRange 0, 0, 800, 600
  SetViewPort 0, 0, 800, 600
  GOSUB DrawShape
  DeallocateXMS sbuffer
RETURN

DrawShape:
  Page = Page XOR 1
  SetPage Page
  Future.MouseOff
  Future.XMSput lx, ly, sbuffer
 
  xE = xP + 2 * (xP > xS) - (xP > xS)
  yE = yP + 2 * (yP > yS) - (yP > yS)
  dx = xE - xS: dy = yE - yS

  SELECT CASE Tool
  CASE 1      'box
    y2 = ly + lww * yE + gridV
    IF dx = 0 THEN
    ELSE
      FOR X = xS TO xE STEP dx \ ABS(dx)
        x2 = lx + lww * X + gridV
        Future.PSET Sx + X, Sy + yS, PColor
        Future.PSET Sx + X, Sy + yE, PColor
        Future.FILLBOX x2, Y1, x2 + w2, Y1 + w2, PColor
        Future.FILLBOX x2, y2, x2 + w2, y2 + w2, PColor
      NEXT X
    END IF
    x2 = lx + lww * xE + gridV
    IF yS > yE THEN SWAP yS, yE
    FOR Y = yS + 1 TO yE - 1
      y2 = ly + lww * Y + gridV
      Future.PSET Sx + xS, Sy + Y, PColor
      Future.PSET Sx + xE, Sy + Y, PColor
      Future.FILLBOX X1, y2, X1 + w2, y2 + w2, PColor
      Future.FILLBOX x2, y2, x2 + w2, y2 + w2, PColor
    NEXT Y
  CASE 2   'line
    IF ABS(dx) > ABS(dy) THEN
      FOR X = xS TO xE STEP dx \ ABS(dx)
        Y = (dy * (X - xS)) \ dx + yS
        y2 = ly + lww * Y + gridV
        x2 = lx + lww * X + gridV
        Future.PSET Sx + X, Sy + Y, PColor
        Future.FILLBOX x2, y2, x2 + w2, y2 + w2, PColor
      NEXT X
    ELSEIF dy = 0 THEN
      Future.PSET Sx + xS, Sy + yS, PColor
      y2 = ly + lww * yS + gridV
      x2 = lx + lww * xS + gridV
      Future.FILLBOX X1, Y1, X1 + w2, Y1 + w2, PColor
    ELSE
      FOR Y = yS TO yE STEP dy \ ABS(dy)
        X = (dx * (Y - yS)) \ dy + xS
        y2 = ly + lww * Y + gridV
        x2 = lx + lww * X + gridV
        Future.PSET Sx + X, Sy + Y, PColor
        Future.FILLBOX x2, y2, x2 + w2, y2 + w2, PColor
      NEXT Y
    END IF
  CASE 3   '**fillbox
    IF dx * dy = 0 THEN RETURN
    FOR Y = yS TO yE STEP dy \ ABS(dy)
      y2 = ly + lww * Y + gridV
      FOR X = xS TO xE STEP dx \ ABS(dx)
        x2 = lx + lww * X + gridV
        Future.PSET Sx + X, Sy + Y, PColor
        Future.FILLBOX x2, y2, x2 + w2, y2 + w2, PColor
      NEXT X
    NEXT Y
  END SELECT
  ViewPage Page
  Future.MouseOn
RETURN

GrabColor:
  Future.MouseOff
  Future.GET mx, my, mx + 2, my + 2, B()
  PColor = B(2) AND 255
  Future.MouseOn
  GOSUB Colorgrabed
RETURN

undo:
  Future.PUT Sx, Sy, undo()
  Future.XMSput lx, ly, undobuffer
  Future.GET Sx, Sy, Sx + sw, Sy + sh, undo()
  Future.XMSget lx, ly, lx2, ly2, undobuffer
RETURN
END SUB

